<?

class nsQueryCache {

    // 
    function nsQueryCache($CpId=false, $QuerySetId=false, $CacheId=false)
    {
        $this->CpId=$CpId;
        $this->QuerySetId=$QuerySetId;
        $this->CacheId=$CacheId;
        $this->SettingsImported=false;

        $this->QueryParams=array(); //   
        $this->QueryHashSet=""; //    
        $this->Md5Hash=""; // md5  QueryHashSet (    )

        $this->ToCache=false; // , ,      
        $this->CacheStamp=false; //    
        $this->CacheType=0; // 0: dynamic constructor, 1: static report, 2: hidden report
                                            // 3: archive cache, 4: prepared archive cache (  )
                                            // 5: funnel, 6: email
        $this->CacheTZ=""; //          
        $this->Mode="CUSTOM"; // PAID, NATURAL, CUSTOM, SPLIT
        $this->UpdateInterval=60; //        ()

        $this->RowsCnt=0; //     
        $this->ExceedLimit=false; //          
        $this->Data=array(); //   
        $this->FormLimit=false; // Limit   

        $this->Additional=array(); //    (OrderBy, OrderTo, Limit)
        $this->AdditionalHash=""; // md5       
        $this->PrevAdditionalStr=""; //         
        $this->PrevAdditional=array(); //  

        $this->CacheEnable=false; //   _config
        $this->CacheSmart=false; //       
        $this->CacheUpdateMode=0; //     ,   
        $this->CacheNeed=true; //   Smart
        $this->CacheSmartTime=0; // ,   
        $this->CacheSmartKeepDays=7; //  ,    report_time_stat
        $this->CacheAgeLimit=false; //    .  .
        $this->CacheAgeLimitExceed=false; //   

        $this->TakenFromCache=false; //  CacheNeed=false ,      realtime

        $this->QueryLogGroupKey=0; // ,    SetQueryLog

        $this->CacheJobLaunched=false;
        $this->CpTZ=array(); //        
    }


    // 
    /////////////////////////////////////////////////////////

    //  
    function CacheJob($QueryArr=array(),$ToCache=false,$Args=array())
    {
        if ($this->CacheJobLaunched) return false;
        $this->CacheJobLaunched=true;
        if (!is_array($QueryArr)) { $QueryArr[]=$QueryArr; $Args[]=$Args; }
        if (empty($QueryArr)) return false;
        global $nsUser,$Db;

        $this->GetSettings();

        //    ,       Args
        if (!empty($Args)) foreach ($QueryArr as $k=>$Query) {
            $QueryArr[$k] = $Db->PrepareQuery($Query,array(@$Args[$k]));
        }

        $this->QueryParams=$QueryArr;
        $this->QuerySetId=$this->GetQuerySetId();

        //      QuerySetId. ?
        if ($this->CacheEnable&&$this->CacheSmart)
            $this->CacheNeed=$this->CheckCacheNeed($this->QuerySetId);

        $this->GetCacheId();
        if ($this->CacheAgeLimitExceed) {
            $this->CacheNeed=false;
            $this->CacheEnable=false;
            $this->NoCache();
        }
        if (!$this->CacheId) {
            $this->CreateCacheRecord();
            if ($ToCache) $this->ToCache=$ToCache;
        }

        if (!$this->CacheEnable || (!$this->CacheNeed && $this->CacheSmart)) {
            $Time1=$Db->GetMicrotime();
            foreach ($QueryArr as $Key=>$Query) {
                $Sql = new Query($Query);
                $TmpArr=array();
                while ($Row=$Sql->Row()) $TmpArr[]=$Row;
                if (count($TmpArr)<2) $TmpArr=V($TmpArr[0]);
                $this->Data[$Key]=$TmpArr;
            }
            $RunTime=$Db->GetMicrotime()-$Time1;
            $this->QuerySetLog($RunTime, $this->QuerySetId, $QueryArr);
            return;
        }

        if (!$this->HasData() && $this->CacheUpdateMode==1) $this->AddToCache();
        elseif ($this->HasData()) {
            $this->TakenFromCache=true;
            $this->GetData();
            $this->Data = &$this->StatArr;
        }
    }

    function GetSettings()
    {
        global $nsUser;
        if ($this->SettingsImported) return false;
        $Settings=GetSettings($this->CpId);
        $this->SettingsImported=true;
        $this->CacheEnable=@$this->IgnoreCacheEnable?$this->CacheEnable:CacheEnabled($Settings);
        $this->CacheNeed=$this->CacheEnable;
        $this->CacheSmart=$Settings['All']->CACHE_SMART_ENABLE;
        $this->CacheSmartTime=$Settings['All']->CACHE_SMART_TIME;
        $this->CacheSmartKeepDays=$Settings['All']->CACHE_SMART_KEEP_DAYS;
        if ($this->CacheSmartKeepDays==0) $this->CacheSmart=false;
        if ($this->CacheSmart && V($nsUser->DISABLE_SMART)) $this->CacheSmart=false;
        $this->CacheUpdateMode=V($nsUser->CACHE_UPDATE_MODE);
    }


    //    Cache
    /////////////////////////////////////////////////////////

    function GetCacheId()
    {
        global $Db, $nsUser;
        if (!$this->QuerySetId) $this->GetQuerySetId();
        if (!$this->QuerySetId) return 0;
        if ($this->CacheId) return $this->CacheId;

        if (defined("CRON_MODE")) {
            if (!isset($this->CpTZ[$this->CpId])) {
                $Query = "SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0";
                $TZ=$Db->ReturnValue($Query,$this->CpId);
                $this->CpTZ[$this->CpId]=$TZ;
            }
            $nsUser->SQL_TZ=SqlTZ($this->CpTZ[$this->CpId]);
        }

        $Query = "SELECT LAST_CACHED_TZ FROM ?_{$this->CpId}_cache C WHERE QUERY_SET_ID=? AND MODE=?";
        $LastTZ = $Db->ReturnValue($Query, $this->QuerySetId, $this->Mode);
        $LastTZ = SqlTZ($LastTZ);

        $AgeLimit="0 AS AGE_LIMIT";
        if ($this->CacheAgeLimit) {
            $Stamp=gmdate("Y-m-d H:i:s", time());
            $AgeLimit=" IF(
                DATE_ADD(LAST_CACHED, INTERVAL '$LastTZ' HOUR_MINUTE) <
                DATE_ADD(DATE_ADD('$Stamp', INTERVAL '$LastTZ' HOUR_MINUTE), INTERVAL -$this->CacheAgeLimit MINUTE)
                , 1, 0)  AS AGE_LIMIT";
        }

        $Query = "
            SELECT C.*,
            UNIX_TIMESTAMP(DATE_ADD(LAST_CACHED, INTERVAL '$LastTZ' HOUR_MINUTE)) AS CACHE_TIME,
            $AgeLimit
            FROM ?_{$this->CpId}_cache C
            WHERE QUERY_SET_ID=? AND MODE=?";
        $Check=$Db->Select($Query, false, $this->QuerySetId, $this->Mode);
        if (defined("DEBUG")&&!$Check) {
            global $nsConsole;
            $nsConsole->DebugMessage("No existing cache found");
        }
        if (!$Check) return false;
        $this->CacheId=$Check->ID;
        $this->ToCache=$Check->TO_CACHE;
        $this->CacheStamp=$Check->CACHE_TIME;
        $this->PrevAdditionalStr=$Check->ADDITIONAL_TASK;
        $this->CacheType=$Check->CACHE_TYPE;
        $this->CacheTZ=$Check->LAST_CACHED_TZ;
        if ($this->CacheTZ==0) $this->CacheTZ=false;
        $this->CacheAgeLimitExceed=$Check->AGE_LIMIT;
        if ($this->CacheTZ==V($nsUser->TZ)) $this->CacheTZ=null;

        if (defined("DEBUG")) {
            global $nsConsole;
            $nsConsole->DebugMessage("CacheId: ".$this->CacheId);
        }
        return $this->CacheId;
    }

    function NoCache()
    {
        //$this->CacheId=false;
        $this->ToCache=false;
        $this->CacheStamp=false;
        $this->PrevAdditionalStr=false;
        $this->CacheType=0;
        $this->CacheTZ="";
        return false;
    }

    function CreateCacheRecord($ToCache=0)
    {
        if (!$this->QuerySetId) $this->GetQuerySetId();
        if (!$this->QuerySetId) return 0;
        $Stamp=gmdate("Y-m-d H:i:s", time());
        global $Db;
        $Query = "INSERT INTO ?_{$this->CpId}_cache
                        (QUERY_SET_ID, LAST_CACHED, TO_CACHE, CACHE_TYPE, MODE, UPDATE_INTERVAL)
                        VALUES (?, ?, ?, ?, ?, ?)";
        $Db->Query($Query, $this->QuerySetId, $Stamp, $ToCache, $this->CacheType, $this->Mode, $this->UpdateInterval);
        $this->CacheId = $Db->LastInsertId;
        $this->GetCacheId();
        $this->ToCache=$ToCache;
        return $this->CacheId;
    }

    function DropCacheRecord()
    {
        global $Db;
        if (!$this->CacheId) $this->GetCacheId();
        if (!$this->CacheId) return false;
        $Query = "DELETE FROM ?_{$this->CpId}_cache WHERE ID = ?";
        $Db->Query($Query, $this->CacheId);
    }

    function SetCacheType($Type=false)
    {
        if (!$this->CacheId) $this->GetCacheId();
        if (!$this->CacheId) return false;
        if (!$Type) return false;
        global $Db;
        $Query = "UPDATE ?_{$this->CpId}_cache SET CACHE_TYPE=? WHERE ID = ?";
        $Db->Query($Query, $Type, $this->CacheId);
        $this->CacheType=$Type;
    }

    function SetUpdateInterval($Interval=false)
    {
        if (!$this->CacheId) $this->GetCacheId();
        if (!$this->CacheId) return false;
        if (!$Interval) return false;
        global $Db;
        $Query = "UPDATE ?_{$this->CpId}_cache SET UPDATE_INTERVAL=? WHERE ID = ?";
        $Db->Query($Query, $Interval, $this->CacheId);
        $this->UpdateInterval=$Interval;
    }

    function AddToCache($CacheId=false)
    {
        global $Db, $Logs;
        if (!$CacheId) {
            if (!$this->CacheId) $this->GetCacheId();
            $CacheId=$this->CacheId;
        }
        $Query = "UPDATE ?_{$this->CpId}_cache
                        SET TO_CACHE='1', ADDITIONAL_TASK=? WHERE ID = ?";
        //  ,    
        //           
        //   ,       
        $Db->Query($Query, $this->AllTasks(), $CacheId);
        $this->ToCache=1;
        $this->UserCache();
        return true;
    }

    //   
    /////////////////////////////////////////////////////////

    //       md5
    //      data,    
    //      
    function AdditionalMd5()
    {
        if (empty($this->Additional)) return $this->AdditionalHash="";
        $Arr=$this->Additional;
        if (isset($Arr['FormLimit'])) unset($Arr['FormLimit']);
        $Arr=$this->SortArrKeys($Arr);
        $this->AdditionalHash=md5(serialize($Arr));
        return $this->AdditionalHash;
    }

    //            
    // array('1'=>1, '2'=>2) --- "1=1;2=2"
    //       cache
    function AdditionalTask()
    {
        $Str="";
        foreach ($this->Additional as $k=>$v) {
            if ($Str!="") $Str.=";";
            $Str.="$k=$v";
        }
        return $Str;
    }

    //       
    function TaskToArr($Str='')
    {
        if (!$Str) return array();
        $Tasks = array();
        $Arr = explode(';', $Str);
        foreach ($Arr as $Row) {
            if (!$Row) continue;
            $Arr2=explode('=', $Row);
            if (count($Arr2) < 2) continue;
            $Tasks[$Arr2[0]]=$Arr2[1];
        }
        return $Tasks;
    }

    //         ,  
    //   .
    //        
    function AllTasks()
    {
        $Str="";
        //      ,    
        if (!$this->PrevAdditionalStr) return $this->AdditionalTask();
        //     
        $this->PrevAdditional=explode("|", $this->PrevAdditionalStr);
        // ,        
        $Task=$this->AdditionalTask();
        //  ,    ,   
        if (in_array($Task, $this->PrevAdditional)) return $this->PrevAdditionalStr;
        //     
        $Arr=$this->PrevAdditional;
        $Arr[]=$Task;
        //      
        $Str=implode("|", $Arr);
        return $Str;
    }






    //    
    /////////////////////////////////////////////////////////

    function HasData()
    {
        global $Db, $nsConsole;
        if (!$this->CacheId) $this->GetCacheId();
        if (!$this->CacheId) return false;
        // ,       
        $Where="";
        if (isset($this->Additional['FormLimit'])) {
            $Where=" AND ROWS_CNT >= ".$this->Additional['FormLimit'];
        }
        if (!$this->AdditionalHash) $this->AdditionalMd5();
        $Query = "SELECT ID FROM ?_{$this->CpId}_cache_data WHERE
                        CACHE_ID = ?
                        AND (LIMIT_EXCEED=0 OR (ADDITIONAL=? $Where))";
        //    ADDITIONAL,     , , 
        return $Db->ReturnValue($Query, $this->CacheId,$this->AdditionalHash);
    }

    function GetData()
    {
        if (!$this->CacheId) $this->GetCacheId();
        if (!$this->CacheId) return false;
        if (!$this->AdditionalHash) $this->AdditionalMd5();
        global $Db, $Logs;
        $Query = "SELECT * FROM ?_{$this->CpId}_cache_data
                        WHERE CACHE_ID=? AND
                        (LIMIT_EXCEED=0 OR ADDITIONAL=?)";
        //    ADDITIONAL,     , , 
        $Data=$Db->Select($Query, false, $this->CacheId, $this->AdditionalHash);
        $this->RowsCnt=$Data->ROWS_CNT;
        $this->ExceedLimit=$Data->LIMIT_EXCEED;
        if (trim($Data->FULL_DATA)) {
            if (substr($Data->FULL_DATA,0,1)=='e') $Data->FULL_DATA=base64_decode($Data->FULL_DATA);
            $Data->FULL_DATA=gzuncompress($Data->FULL_DATA);
            $Stat=unserialize($Data->FULL_DATA);
        }
        else $Stat=false;
         $this->StatArr=$Stat;
        return $Stat;
    }







    //   Query Set
    /////////////////////////////////////////////////////////
    function GetQuerySetId()
    {
        global $Db;
        if (!$this->Md5Hash) $this->Md5Hash();
        if (!$this->Md5Hash) return 0;
        $Query = "SELECT ID FROM ?_{$this->CpId}_cache_query_set WHERE MD5_SEARCH = ?";
        $CheckId=$Db->ReturnValue($Query, $this->Md5Hash);
        if ($CheckId) $this->QuerySetId=$CheckId;
        if (!$CheckId) {
            $Query = "INSERT INTO ?_{$this->CpId}_cache_query_set (MD5_SEARCH, PARAMS_SET) VALUES (?, ?)";
            $Db->Query($Query, $this->Md5Hash, $this->QueryHashSet);
            $this->QuerySetId=$Db->LastInsertId;
        }
        if (defined("DEBUG")) {
            global $nsConsole;
            $nsConsole->DebugMessage("QuerySetId: ".$this->QuerySetId);
        }
        return $this->QuerySetId;
    }

    //  md5 ,     query set  
    function Md5Hash()
    {
        if (!$this->QueryHashSet) $this->QueryHashSet=serialize($this->SortArrKeys($this->QueryParams));
        $this->Md5Hash=md5($this->QueryHashSet);
    }

    //   Query Params   ,        .
    //    md5    
    function SortArrKeys($Arr)
    {
        $Keys=array_keys($Arr);
        sort($Keys);
        $Arr2=array();
        foreach ($Keys as $Key) {
            if (is_array($Arr[$Key])) $Arr[$Key]=$this->SortArrKeys($Arr[$Key]);
            $Arr2[$Key]=(!is_array($Arr[$Key]))?(string) $Arr[$Key]:$Arr[$Key];
        }
        return $Arr2;
    }






    //   
    /////////////////////////////////////////////////////////

    //  
    //     query set
    //    explain
    // -1 -  , 0 - .    , 1 -   . 
    function CheckCacheNeed()
    {
        if (!$this->QuerySetId||!$this->CacheSmartTime) return false;
        if ($this->CacheSmartKeepDays==0) return false;
        $Check1=$Check2=0;
        $Check1=$this->CheckCacheByQuerySet();
        if ($Check1<0) $Check2= $this->CheckCacheByExplain($this->GetCacheExplain($this->QuerySetId));
        if (defined("DEBUG")) {
            global $nsConsole;
            $nsConsole->DebugMessage("By query set: $Check1, By explain: $Check2   (-1 unknown, 0 cache not needed, 1 cache needed)");
            if ($Check1>0 || $Check2>0) $nsConsole->DebugMessage("Cache needed.");
            if ($Check1<1 && $Check2<1) $nsConsole->DebugMessage("Cache not needed.");
        }
        if ($Check1<0 && $Check2 <0) return true;
        return ($Check1>0 || $Check2>0)?true:false;
    }

    //  ,     
    function GetCacheExplain()
    {
        global $Db;
        $Query = "SELECT PARAMS_SET FROM ?_{$this->CpId}_cache_query_set WHERE ID=?";
        $QueryArr=unserialize($Db->ReturnValue($Query, $this->QuerySetId));
        $ExplainArr=array();
        foreach ($QueryArr as $Query) {
            $Sql = new Query("EXPLAIN ".$Query);
            while ($Row=$Sql->Row()) $ExplainArr[]=$Row;
        }
        return $ExplainArr;
    }

    //     query set
    function CheckCacheByQuerySet()
    {
        global $Db;
        $Query = "SELECT MIN(RUN_TIME) AS MI, MAX(RUN_TIME) AS MA, COUNT(*) AS CNT FROM ?_report_time_stat
                            WHERE COMPANY_ID= {$this->CpId} AND  QUERY_SET_ID=?";
        $Stat=$Db->Select($Query, false, $this->QuerySetId);
        if ($Stat->CNT<3) return -1;
        $Query = "SELECT AVG(RUN_TIME) FROM ?_report_time_stat
                            WHERE COMPANY_ID= ? AND  QUERY_SET_ID=?
                            AND RUN_TIME BETWEEN ? AND ? ";
        $AvgTime=$Db->ReturnValue($Query, $this->CpId, $this->QuerySetId, $Stat->MI, $Stat->MA);
        if (defined("DEBUG")) {
            global $nsConsole;
            $nsConsole->DebugMessage("Avg for query set ".$this->QuerySetId.": $AvgTime");
        }
        if (!$AvgTime) return -1;
        return ($AvgTime >= $this->CacheSmartTime)?1:0;
    }

    //     explain
    //      ,    explain   
    function CheckCacheByExplain($ExplainArr=array())
    {
        global $Db;
        $JoinCnt=0; $Rows=0;

        foreach ($ExplainArr as $Row ) {
            if (!ValidVar($Row->rows)) continue;
            $JoinCnt++;
            $Rows+=$Row->rows;
        }
        if ($Rows==0) return 0;
        if ($Rows<1000) return 0;

        $Query = "
            SELECT
            (AVG(TS1.RUN_TIME)+AVG(TS2.RUN_TIME)+AVG(TS3.RUN_TIME)) AS AV, COUNT(*) AS CNT
            FROM ?_report_time_stat TS1
            INNER JOIN ?_report_time_stat TS2
                  ON TS2.ID!=TS1.ID AND TS2.GROUP_KEY=TS1.ID AND TS2.QUERY_TYPE=1
            INNER JOIN ?_report_time_stat TS3
                  ON TS3.ID!=TS1.ID AND TS3.GROUP_KEY=TS1.ID AND TS3.QUERY_TYPE=2
            WHERE TS1.COMPANY_ID={$this->CpId} AND TS1.JOIN_CNT = $JoinCnt
                                AND TS1.ROWS_CNT BETWEEN $Rows-5000 AND $Rows+5000
                                AND TS1.QUERY_TYPE=0
        ";
        $Stat=$Db->Select($Query);
        if ($Stat->CNT < 3) return -1;
        $AvgTime=$Stat->AV;
        if (!$AvgTime) {
            $Query = "
                SELECT
                MAX(ROWS_CNT), ID
                FROM ?_report_time_stat
                WHERE JOIN_CNT=$JoinCnt AND ROWS_CNT < $Rows AND QUERY_TYPE=0
                GROUP BY JOIN_CNT
            ";
            $Check=$Db->Select($Query);
            if (!$Check) return -1;
            $Query = "SELECT SUM(RUN_TIME) FROM ?_report_time_stat
                                WHERE GROUP_KEY = ?";
            $AvgTime=$Db->ReturnValue($Query, $Check->ID);
        }
        if (defined("DEBUG")) {
            global $nsConsole;
            $nsConsole->DebugMessage("Avg for explain: $AvgTime");
        }
        return ($AvgTime >= $this->CacheSmartTime)?1:0;
    }







    //  
    /////////////////////////////////////////////////////////

    //    
    //      ,   ,   
    function QuerySetLog($RunTime, $QuerySetId=0, $QueryArr=array(), $QueryType=0, $ArgsArr=array())
    {
        global $Db;
        if ($this->CacheSmartKeepDays==0) return false;
        $JoinCnt=0; $RowsCnt=0;
        if (!$this->QueryLogGroupKey) $this->QueryLogGroupKey=0;
        if (!$QuerySetId) $QuerySetId=0;
        if (!$QuerySetId && isset($this->QuerySetId) && $this->QuerySetId) $QuerySetId=$this->QuerySetId;
        if (!empty($QueryArr)) {
            $ExpainArr=array();
            if (!is_array($QueryArr)) { $Q[]=$QueryArr; $QueryArr=$Q; }
            foreach ($QueryArr as $k=>$Query) {
                $Sql = new Query("EXPLAIN ".$Query,false,@$ArgsArr[$k]);
                while ($Row=$Sql->Row()) $ExpainArr[]=$Row;
            }
            foreach ($ExpainArr as $Row ) {
                if (!ValidVar($Row->rows)) continue;
                $JoinCnt++;
                $RowsCnt+=$Row->rows;
            }
        }
        $Query = "
            INSERT INTO ?_report_time_stat
            (STAMP, QUERY_SET_ID, RUN_TIME, COMPANY_ID, JOIN_CNT, ROWS_CNT, QUERY_TYPE, GROUP_KEY)
            VALUES (NOW(), ?, ?, ?, ?, ?, ?, ?)";
        $Db->Query($Query, $QuerySetId, $RunTime, $this->CpId, $JoinCnt, $RowsCnt, $QueryType, $this->QueryLogGroupKey);
        if (!$this->QueryLogGroupKey) {
            $this->QueryLogGroupKey=$Db->LastInsertId;
            $Query = "UPDATE ?_report_time_stat SET GROUP_KEY = ? WHERE ID = ?";
            $Db->Query($Query, $this->QueryLogGroupKey, $this->QueryLogGroupKey);
        }
    }

}

?>