<?

require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/class/customreport.class.php";

class Funnel extends CustomReport  {

    function Funnel($CpId=false, $CacheId=false,$FId=false) {
        $this->nsQueryCache($CpId,false,$CacheId);
        $this->GetSettings();
        $this->CpId=$CpId;
        $this->FunnelId=$FId;
        $this->LastPosition=0;
        $this->Steps = $this->GetSteps();
        $this->CustomId=4;
        $this->CacheSmart = false;
        $this->CacheEnable = true;
        $this->CacheNeed = true;
        $this->IgnoreCacheEnable = true;
        $this->CronOnly = true;
        $this->NonRealTime = true;
        $this->CacheType = 5;

        $this->Filter = array();
        $this->Data = array();
        $this->Queries = array();
        $this->JoinArr = $this->WhereArr = $this->Args = array();
        $this->Args['mark']='?';
        $this->JoinMode='session';

        $this->StartDay = false;
        $this->EndDay = false;
        $this->SiteId = false;

        $this->OutsUseValue=false; //  not exists     
                                                     //  ,    straight_join
    }

    function GetSteps() 
    {
        global $Lang,$nsLang;
        $nsLang->TplInc("admin.funnels");

        $Query = "
            SELECT PS.*, 
                CP.NAME AS CAMP_NAME, SPL.NAME AS SPLIT_NAME, 
                VA.NAME AS ACTION_NAME, AI.NAME AS ACTION_ITEM_NAME,
                SI.NAME AS PRODUCT_NAME,
                SP.PATH, Q.QUERY_STRING, SH.HOST,
                HG.NAME AS HOST_GRP_NAME, H.HOST AS HOST_NAME,
                K.KEYWORD
            FROM ?_path_step PS
                LEFT JOIN ?_camp_piece CP ON CP.ID=PS.CAMP_ID #campaign 
                LEFT JOIN ?_camp_piece SPL ON SPL.ID=PS.SPLIT_ID #split test
                LEFT JOIN ?_visitor_action VA ON VA.ID=PS.ACTION_ID #action
                LEFT JOIN ?_action_item AI ON AI.ID=PS.ACTION_ITEM_ID #action item
                LEFT JOIN ?_sale_item SI ON SI.ID=PS.PRODUCT_ID #product item

                LEFT JOIN ?_page_query PQ ON PQ.ID=PS.PQ_ID
                    LEFT JOIN ?_site_page SP ON SP.ID=PQ.PAGE_ID
                    LEFT JOIN ?_query Q ON Q.ID=PQ.QUERY_ID
                    LEFT JOIN ?_site_host SH ON SH.ID=PQ.SITE_HOST_ID

                LEFT JOIN ?_host_grp HG ON HG.ID=PS.REF_GRP_ID
                LEFT JOIN ?_host H ON H.ID=PS.REF_HOST_ID

                LEFT JOIN ?_keyword K ON K.ID=PS.KEYWORD_ID
            WHERE PS.PATH_ID=? 
            ORDER BY PS.POSITION ASC
        ";
        $Steps=array();
        $Sql = new Query($Query,false,$this->FunnelId);
        while ($Row=$Sql->Row()) {
            $this->LastPosition = $Row->POSITION;
            $Row->NAME=false;
            $Row->SUB_NAME=false;
            if ($Row->CAMP_ID||$Row->ANY_CAMPAIGN) {
                $Row->TYPE='click';
                $Row->NAME=$Row->CAMP_NAME? $Row->CAMP_NAME: $Lang['AnyCamp'];
                $Row->SUB_NAME = $Row->KEYWORD? $Row->KEYWORD: $Lang['AnyKeyword'];
            }
            if ($Row->SPLIT_ID||$Row->ANY_SPLIT_TEST) {
                $Row->TYPE='split';
                $Row->NAME=$Row->SPLIT_NAME? $Row->SPLIT_NAME: $Lang['AnySplit'];
            }
            if ($Row->ACTION_ID||$Row->ACTION_ITEM_ID||$Row->ANY_ACTION) {
                $Row->TYPE='action';
                $Row->NAME=$Row->ACTION_NAME? $Row->ACTION_NAME: $Lang['AnyAction'];
                $Row->SUB_NAME=$Row->ACTION_ITEM_NAME ?$Row->ACTION_ITEM_NAME: $Lang['AnyActionItem'];
            }
            if ($Row->PRODUCT_ID||$Row->ANY_SALE) {
                $Row->TYPE='sale';
                $Row->NAME = $Row->PRODUCT_NAME? $Row->PRODUCT_NAME: $Lang['AnyProduct'];
            }
            if ($Row->PQ_ID) {
                $Row->TYPE='page';
                $Row->NAME = 'http://'.$Row->HOST.$Row->PATH;
                if ($Row->QUERY_STRING) $Row->NAME.='?'.$Row->QUERY_STRING;
                if ($Row->ANY_QUERY_STRING) $Row->SUB_NAME = $Lang['AnyQuery'];
            }
            if ($Row->REF_GRP_ID||$Row->REF_HOST_ID||$Row->ANY_REFERER) {
                $Row->NAME = $Row->HOST_GRP_NAME;
                if ($Row->NAME && $Row->HOST_NAME) $Row->NAME .= "($Row->HOST_NAME)";
                elseif (!$Row->NAME && $Row->HOST_NAME) $Row->NAME = $Row->HOST_NAME;
                else $Row->NAME = $Lang['AnyReferer'];
                $Row->SUB_NAME = $Row->KEYWORD;
                $Row->TYPE='ref';
            }
            if ($Row->ANY_ENTRY) {
                $Row->NAME = $Row->ANY_ENTRY == 2? $Lang['Direct']:$Lang['EntryPoint']; 
                $Row->TYPE='entry';
            }
            $Row->Res = false;
            $Row->OutsUseValue=false;
            $Steps[$Row->POSITION]=$Row;
        }
        return $Steps;
    }

    function GetQuery() 
    {
        $this->Subs=array();
        foreach ($this->Steps as $p=>$Row) {
            $this->Queries[$p] = $this->GetStepQuery($Row);
            //$this->Steps[$p]->Query = $this->Queries[$p]['cnt']; 
        }
    }

    function Calculate()
    {
        global $Db, $nsConsole;
        $this->SetWhere();
        $this->GetQuery();
        $QArr = $AArr = array();
        foreach ($this->Queries as $p=>$Arr) {
            $QArr[$p]=$Arr['cnt'];
            $AArr[$p]=$this->Args;
            if ($nsConsole) $nsConsole->SqlRecord($Db->PrepareQuery($Arr['cnt'],array(0=>$this->Args)));
            if ($Arr['out']) {
            $QArr[$p.'_out']=$Arr['out'];
            $AArr[$p.'_out']=$this->Args;
            if ($nsConsole) $nsConsole->SqlRecord($Db->PrepareQuery($Arr['out'],array(0=>$this->Args)));
            }
            if ($Arr['return']) {
            $QArr[$p.'_return']=$Arr['return'];
            $AArr[$p.'_return']=$this->Args;
            if ($nsConsole) $nsConsole->SqlRecord($Db->PrepareQuery($Arr['return'],array(0=>$this->Args)));
            }
        }
        $this->CacheJob($QArr,false,$AArr);
        $StartColor=0xcc3300;
        $EndColor=0x99cc33;
        $S1=$this->deRGB($StartColor);
        $S2=$this->deRGB($EndColor);

        $Total = (!empty($this->Data)) ? @$this->Data[1]->CNT : 0;
        foreach ($this->Steps as $k=>$Step) {
            if (!isset($this->Data[$k])) continue;
            $Row =& $this->Data[$k];
            if (isset($this->Data[$k.'_out']->PATH)) $this->Data[$k.'_out'] = array(0=>$this->Data[$k.'_out']);
            if (isset($this->Data[$k.'_return']->PATH)) $this->Data[$k.'_return'] = array(0=>$this->Data[$k.'_return']);
            $Row->COLOR = '666';
            $Row->PERC =  ($Total > 0) ? round( (100* $Row->CNT ) / $Total , 2) : 0;
            $Row->PREV_PERC = ($Total > 0 && $k > 1 && $this->Data[$k-1]->CNT > 0 && $Row->CNT > 0) ? 
                                                round( (100* $Row->CNT ) / $this->Data[$k-1]->CNT , 2) : 0;
            $this->Data[$k]=$Row;
            if ($Total == 0) continue;
            $S3['R']=ceil($S1['R']+(($S2['R']-$S1['R'])*($Row->PERC/100)));
            $S3['G']=ceil($S1['G']+(($S2['G']-$S1['G'])*($Row->PERC/100)));
            $S3['B']=ceil($S1['B']+(($S2['B']-$S1['B'])*($Row->PERC/100)));
            $Row->COLOR = dechex(($S3['R'] << 16)+($S3['G'] << 8)+$S3['B']);
            $Row->ARROW_CNT = ceil ((10 * $Row->PERC) / 100);

            $this->Data[$k]=$Row;
        }
    }

    function deRGB($Hex)
    {
            $R = ($Hex & 0xFF0000) >> 16;
            $G = ($Hex & 0x00FF00) >> 8;
            $B = $Hex & 0x0000FF;
            return array("R"=>$R,"G"=>$G,"B"=>$B);
    }

    function SetWhere()
    {
        global $nsUser, $Db;

        extract($this->Filter);
        $StartDay=$EndDay=false;
        if (V($DynamicPeriod)!="-1" && V($DynamicPeriod)!==""  && V($DynamicPeriod)!=="0-a-0") {
            $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
            $StartDate=$DynamicDate['StartDate'];
            $EndDate=$DynamicDate['EndDate'];
            $ViewDate="";
        }
        else {
            if (V($StartDate)) $StartDate.=" 00:00:00";
            if (V($EndDate)) $StartDate.=" 00:00:00";
        }
        $StartDay=$StartDate; $EndDay=$EndDate;     

        if (V($ViewDate)) {
            $EndDay=$Db->ReturnValue("SELECT DATE_ADD('$ViewDate', INTERVAL 1 DAY)")." 00:00:00";
            $StartDay=$ViewDate." 00:00:00";
        }

        $this->StartDay = $StartDay;
        $this->EndDay = $EndDay;
        $this->SiteId = $SiteId;

        $this->Args['siteid']=$SiteId;
        $this->Args['startdate']=$StartDay;
        $this->Args['enddate']=$EndDay;
        $this->Args['tz']=$nsUser->_SQL_TZ;

    }

    function GetStepQuery($Step)
    {
        global $Db, $nsUser;
        $WhereArr = $OutsWhere = $CntWhere = $JoinArr = $CmnJoin = $OutsJoin = $Args = array();
        $OutsCmnJoin = $OutsCmnWhere = array();
        $Select = $From = $GroupBy = '';

        $Px = "_{$Step->POSITION}";
        $LogName = "S_LOG$Px";

        if ($Step->POSITION==1 && (in_array($Step->TYPE,array('click','split','ref')) || $Step->ANY_ENTRY==1)) 
            $this->JoinMode='node';

        if ( ($Step->POSITION==1 && ($Step->FIRST_STEP || $Step->FIRST_SESSION)) || 
              ($Step->POSITION > 1 && $this->JoinMode!='node')) {
            if ($Step->FIRST_STEP) {
                $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_session SESS{$Px} 
                    ON SESS{$Px}.START_LOG_ID=S_LOG{$Px}.ID";
                $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_session_log SESS_LOG{$Px} 
                    ON SESS_LOG{$Px}.LOG_ID=S_LOG{$Px}.ID";
            }
            else {
                $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_session_log SESS_LOG{$Px} 
                    ON SESS_LOG{$Px}.LOG_ID=S_LOG{$Px}.ID";
                $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_session SESS{$Px} 
                    ON SESS{$Px}.ID=SESS_LOG{$Px}.SESSION_ID";
            }
        }
        if ($this->Steps[1]->FIRST_SESSION && $this->JoinMode=='session') {
            $CntWhere[]="SESS{$Px}.FIRST_SESSION='1' ";
            $OutsWhere[]="SESS{$Px}.FIRST_SESSION='1' ";
        }
        
        if ($Step->POSITION == 1 && $Step->FIRST_STEP && $this->JoinMode='session') {
            $CntWhere[] = "SESS_1.START_LOG_ID = S_LOG_1.ID";
        }

        if ($Step->POSITION>1) {

            $PrevStep =& $this->Steps[$Step->POSITION-1];
            $FStep =& $this->Steps[1];

            //       ,   
            $CntWhere[]="$LogName.STAMP > S_LOG_".($Step->POSITION-1).".STAMP ";
            $OutsWhere[]="$LogName.STAMP >= S_LOG_".($Step->POSITION-1).".STAMP";
            //     -  ,     
            if ($this->JoinMode=='node') {
                $JoinArr[]="INNER JOIN ?_{$this->CpId}_stat_log $LogName ON $LogName.COOKIE_LOG = S_LOG_1.ID";
                $OutsWhere[] = "$LogName.COOKIE_LOG = S_LOG_".($Step->POSITION-1).".COOKIE_LOG";
            }
            else { //    -  ,    
                $JoinArr[]="INNER JOIN ?_{$this->CpId}_stat_log $LogName 
                    ON $LogName.VISITOR_ID = S_LOG_".($Step->POSITION-1).".VISITOR_ID";
                $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_session_log SESS_LOG{$Px} 
                        ON SESS_LOG{$Px}.LOG_ID={$LogName}.ID";
                if (!$Step->NO_OUTS) {
                    //        
                    $OutsCmnJoin[] = "INNER JOIN ?_{$this->CpId}_stat_session_log SESS_LOG_1 
                            ON SESS_LOG_1.LOG_ID=S_LOG_1.ID";
                    $JoinArr[]="INNER JOIN ?_{$this->CpId}_stat_session_log SESS_LOG_1 
                            ON SESS_LOG_1.LOG_ID=S_LOG_1.ID";
                    $WhereArr[]="SESS_LOG{$Px}.SESSION_ID=SESS_LOG_1.SESSION_ID";
                }
                else {
                    //     ,       
                    $WhereArr[]="SESS_LOG{$Px}.PREV_LOG_ID = S_LOG_".($Step->POSITION-1).".ID"; 
                }
            }
            //      exists
            $OutsWhere[]="$LogName.VISITOR_ID = S_LOG_".($Step->POSITION-1).".VISITOR_ID";
            $CntWhere[]="$LogName.VISITOR_ID = S_LOG_".($Step->POSITION-1).".VISITOR_ID";
        }

        if (!$Step->NO_OUTS && $Step->POSITION==1 && $this->JoinMode == 'session') {
            $OutsCmnJoin[] = "INNER JOIN ?_{$this->CpId}_stat_session_log SESS_LOG_1 
                            ON SESS_LOG_1.LOG_ID=S_LOG_1.ID";
        }

        if ($Step->TYPE=='click') {
            $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_click S_CLICK{$Px} ON S_CLICK{$Px}.LOG_ID={$LogName}.ID";
            if ($Step->CAMP_ID) {
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
                $WhereArr[]="S_CLICK{$Px}.CAMP_ID=?camp{$Step->POSITION}";
                $Args['camp'.$Step->POSITION]=$Step->CAMP_ID;
            }
            if ($Step->KEYWORD_ID) {
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
                $WhereArr[]="S_CLICK{$Px}.KEYWORD_ID=?keyid{$Step->POSITION}";
                $Args['keyid'.$Step->POSITION]=$Step->KEYWORD_ID;
            }
        }

        if ($Step->TYPE=='split') {
            $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_split S_SPLIT{$Px} ON S_SPLIT{$Px}.LOG_ID={$LogName}.ID";
            if ($Step->SPLIT_ID) {
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
                $WhereArr[]="S_SPLIT{$Px}.SPLIT_ID=?split{$Step->POSITION}";
                $Args['split'.$Step->POSITION]=$Step->SPLIT_ID;
            }
        }
    
        if ($Step->TYPE=='ref') {
            $CmnJoin[]="INNER JOIN ?_referer_set RS{$Px} ON RS{$Px}.ID={$LogName}.REFERER_SET";
            if ($Step->REF_GRP_ID) {
                $CmnJoin[]="INNER JOIN ?_host H{$Px} ON H{$Px}.ID=RS{$Px}.HOST_ID";
            }
            if ($Step->REF_GRP_ID) {$WhereArr[]="H{$Px}.GRP_ID=?hgrp{$Step->POSITION}";$Args['hgrp'.$Step->POSITION]=$Step->REF_GRP_ID;}
            if ($Step->REF_HOST_ID) {$WhereArr[]="RS{$Px}.HOST_ID=?host{$Step->POSITION}";$Args['host'.$Step->POSITION]=$Step->REF_HOST_ID;}
            if ($Step->KEYWORD_ID) {$WhereArr[]="RS{$Px}.NATURAL_KEY=?keyid{$Step->POSITION}";$Args['keyid'.$Step->POSITION]=$Step->KEYWORD_ID;}
            if ($Step->REF_GRP_ID || $Step->REF_HOST_ID || $Step->KEYWORD_ID)
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
        }

        if ($Step->ANY_ENTRY) {
            $Step->FIRST_STEP=1;
            if ($Step->ANY_ENTRY==2) {
                $CmnJoin[]="LEFT JOIN ?_{$this->CpId}_stat_click ENTRY_CLICK{$Px} 
                        ON ENTRY_CLICK{$Px}.LOG_ID={$LogName}.ID";
                $CmnJoin[]="LEFT JOIN ?_{$this->CpId}_stat_split ENTRY_SPLIT{$Px} 
                        ON ENTRY_SPLIT{$Px}.LOG_ID={$LogName}.ID";
                $WhereArr[]="{$LogName}.REFERER_SET=0";
                $WhereArr[]="ENTRY_CLICK{$Px}.ID IS NULL";
                $WhereArr[]="ENTRY_SPLIT{$Px}.ID IS NULL";
            }
        }

        if ($Step->TYPE=='sale') {
            $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_sale S_SALE{$Px} ON S_SALE{$Px}.LOG_ID={$LogName}.ID";
            if ($Step->PRODUCT_ID) {
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
                $CmnJoin[]="INNER JOIN ?_sale_set SS{$Px} ON SS{$Px}.SALE_ID=S_SALE{$Px}.ID";
                $WhereArr[]="SS{$Px}.ITEM_ID=?prod{$Step->POSITION}";
                $Args['prod'.$Step->POSITION]=$Step->PRODUCT_ID;
            }
        }

        if ($Step->TYPE=='action') {
            $CmnJoin[]="INNER JOIN ?_{$this->CpId}_stat_action S_ACTION{$Px} 
                    ON S_ACTION{$Px}.LOG_ID={$LogName}.ID";
            if ($Step->ACTION_ID) {
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
                $WhereArr[]="S_ACTION{$Px}.ACTION_ID=?action{$Step->POSITION}";
                $Args['action'.$Step->POSITION]=$Step->ACTION_ID;
            }
            if ($Step->ACTION_ITEM_ID) {
                $this->Steps[$Step->POSITION]->OutsUseValue=true;
                $CmnJoin[]="INNER JOIN ?_action_set ASET{$Px} ON ASET{$Px}.STAT_ACTION_ID=S_ACTION{$Px}.ID";
                $WhereArr[]="ASET{$Px}.ACTION_ITEM_ID=?aitem{$Step->POSITION}";
                $Args['aitem'.$Step->POSITION]=$Step->ACTION_ITEM_ID;
            }
        }

        if ($Step->TYPE=='page'&&$Step->PQ_ID) {
            $this->Steps[$Step->POSITION]->OutsUseValue=true;
            if (!$Step->ANY_QUERY_STRING) {
                $CmnJoin[]="INNER JOIN ?_page_query PQ{$Px} 
                    ON PQ{$Px}.SITE_HOST_ID={$LogName}.SITE_HOST_ID 
                    AND PQ{$Px}.PAGE_ID={$LogName}.PAGE_ID 
                    AND PQ{$Px}.QUERY_ID={$LogName}.QUERY_ID";
                $WhereArr[]="PQ{$Px}.ID=?pq{$Step->POSITION}";
                $Args['pq'.$Step->POSITION]=$Step->PQ_ID;
            }
            else {
                $Query = "SELECT * FROM ?_page_query WHERE ID=?";
                $Pq=$Db->Select($Query,false,$Step->PQ_ID);
                $WhereArr[]="{$LogName}.SITE_HOST_ID=?shost{$Step->POSITION}";
                $WhereArr[]="{$LogName}.PAGE_ID=?spage{$Step->POSITION}";
                $Args['shost'.$Step->POSITION]=$Pq->SITE_HOST_ID;
                $Args['spage'.$Step->POSITION]=$Pq->PAGE_ID;
            }
        }

        if ($this->StartDay&&!$this->EndDay) {
            $CntWhere[]="$LogName.STAMP >= DATE_ADD(?startdate, INTERVAL ?tz HOUR)";
            $OutsWhere[]="$LogName.STAMP >= DATE_ADD(?startdate, INTERVAL ?tz HOUR)";
            $OutsCmnWhere[]="s1.STAMP >= DATE_ADD(?startdate, INTERVAL ?tz HOUR)";
        }
        if (!$this->StartDay&&$this->EndDay) {
            $CntWhere[]="$LogName.STAMP <= DATE_ADD(?enddate, INTERVAL ?tz HOUR)";
            $OutsWhere[]="$LogName.STAMP <= DATE_ADD(?enddate, INTERVAL ?tz HOUR)";
            $OutsCmnWhere[]="s1.STAMP <= DATE_ADD(?enddate, INTERVAL ?tz HOUR)";
        }
        if ($this->StartDay&&$this->EndDay) {
            $CntWhere[]="$LogName.STAMP BETWEEN DATE_ADD(?startdate, INTERVAL ?tz HOUR) AND 
                DATE_ADD(?enddate, INTERVAL ?tz HOUR)";
            $OutsWhere[]="$LogName.STAMP BETWEEN DATE_ADD(?startdate, INTERVAL ?tz HOUR) AND 
                DATE_ADD(?enddate, INTERVAL ?tz HOUR)";          
            $OutsCmnWhere[]="s1.STAMP BETWEEN DATE_ADD(?startdate, INTERVAL ?tz HOUR) AND 
                DATE_ADD(?enddate, INTERVAL ?tz HOUR)";                              
        }
        if ($this->SiteId) {
            $CntWhere[]="$LogName.SITE_ID = ?";
            $OutsWhere[]="$LogName.SITE_ID = ?";
            $OutsCmnWhere[]="s1.SITE_ID = ?";
        }

        $JoinArr = $this->ClearQueryParts($JoinArr);
        $CmnJoin = $this->ClearQueryParts($CmnJoin);
        $OutsCmnJoin = $this->ClearQueryParts($OutsCmnJoin);
        $WhereArr = $this->ClearQueryParts($WhereArr);
        $OutsWhere = $this->ClearQueryParts($OutsWhere);
        $CntWhere = $this->ClearQueryParts($CntWhere);
        $OutsCmnWhere = $this->ClearQueryParts($OutsCmnWhere);

        $this->Steps[$Step->POSITION]->Q['JoinArr']=$JoinArr;
        $this->Steps[$Step->POSITION]->Q['CmnJoin']=$CmnJoin;
        $this->Steps[$Step->POSITION]->Q['OutsCmnJoin']=$OutsCmnJoin;
        $this->Steps[$Step->POSITION]->Q['WhereArr']=$WhereArr;
        $this->Steps[$Step->POSITION]->Q['OutsWhere']=$OutsWhere;
        $this->Steps[$Step->POSITION]->Q['CntWhere']=$CntWhere;
        $this->Steps[$Step->POSITION]->Q['OutsCmnWhere']=$OutsCmnWhere;

        $this->JoinArr = array_merge($this->JoinArr,$JoinArr);
        $this->JoinArr = array_merge($this->JoinArr,$CmnJoin);
        $this->WhereArr = array_merge($this->WhereArr,$WhereArr);
        $this->Args = array_merge($this->Args,$Args);

        $this->JoinArr=array_unique($this->JoinArr);
        $this->WhereArr=array_unique($this->WhereArr);
        $JoinStr=(!empty($this->JoinArr))?implode("\n",array_merge($this->JoinArr)):"";
        $CurrentWhereArr = array();
        foreach ($this->Steps as $StepRow) {
            if (!isset($StepRow->Q)) continue;
            $CurrentWhereArr = array_merge($CurrentWhereArr,$StepRow->Q['WhereArr'],$StepRow->Q['CntWhere']);
        }
        $CurrentWhereArr=array_unique($CurrentWhereArr);
        $WhereStr=(!empty($CurrentWhereArr))?"WHERE ".implode("\nAND ",$CurrentWhereArr):"";

        $QArr = array('cnt'=>'', 'out'=>'', 'return'=>'');
        $Query = "
            SELECT count(distinct {$LogName}.VISITOR_ID) AS CNT
            FROM ?_{$this->CpId}_stat_log S_LOG_1
            $JoinStr
            $WhereStr
        ";
        $Query = preg_replace("/[\t ]+/"," ",$Query);
        $QArr['cnt'] = $Query;

        if ($Step->POSITION>1) {
            $QArr['out'] = $this->GetStepOuts($Step);
            $QArr['return'] = $Step->NO_OUTS?'':$this->GetStepReturns($Step);
        }

        return $QArr;
    }

    function GetStepOuts($Step) 
    {
        $JoinStr = $WhereStr = $StepJoinStr = $StepWhereStr = '';
        $JoinArr = $WhereArr = $SteJoinArr = $StepWhereArr = array();

        for($i=1 ; $i<$Step->POSITION; $i++) {
            $JoinArr = array_merge($JoinArr,$this->Steps[$i]->Q['JoinArr']);
            $JoinArr = array_merge($JoinArr,$this->Steps[$i]->Q['CmnJoin'],$this->Steps[$i]->Q['OutsCmnJoin']);
            $WhereArr = array_merge($WhereArr,$this->Steps[$i]->Q['WhereArr']);
            $WhereArr = array_merge($WhereArr,$this->Steps[$i]->Q['CntWhere'],$this->Steps[$i]->Q['OutsCmnWhere']);
        }
        $WhereArr=array_unique($WhereArr);
        $JoinArr=array_unique($JoinArr);

        $StepJoinArr = $this->Steps[$Step->POSITION]->Q['CmnJoin'];
        $StepWhereArr = $this->Steps[$Step->POSITION]->Q['WhereArr'];
        $StepWhereArr = array_merge($StepWhereArr,$this->Steps[$i]->Q['OutsWhere']);
        $StepJoinArr=array_unique($StepJoinArr);
        $StepWhereArr=array_unique($StepWhereArr);

        $JoinStr=(!empty($JoinArr))?implode("\n",$JoinArr):"";
        $WhereStr=(!empty($WhereArr))?"WHERE ".implode("\nAND ",$WhereArr):"";        
        $StepJoinStr=(!empty($StepJoinArr))? implode("\n",$StepJoinArr):"";
        $StepWhereStr=(!empty($StepWhereArr))?"WHERE ".implode("\nAND ",$StepWhereArr):"";                

        $Query = "
            select
            concat('http://', sh.HOST, sp.PATH, IF( q.QUERY_STRING IS NOT NULL, concat(?mark, q.QUERY_STRING ) , '')) as PATH,
            count(distinct s1.visitor_id) as CNT
            from ?_{$this->CpId}_stat_log S_LOG_1

            $JoinStr

            inner join ?_{$this->CpId}_stat_session_log slog1 on slog1.prev_log_id = S_LOG_".($Step->POSITION-1).".id
            inner join ?_{$this->CpId}_stat_log s1 on s1.id = slog1.log_id
            inner join ?_page_query pq
                on pq.site_host_id = s1.site_host_id
              and pq.page_id = s1.page_id
              and pq.query_id = s1.query_id
            inner join ?_site_page sp on sp.id = pq.page_id
            inner join ?_site_host sh on sh.id = pq.site_host_id
            left join ?_query q on q.id=pq.query_id

            $WhereStr
            and not exists (
                select ".($this->Steps[$Step->POSITION]->OutsUseValue?"":"straight_join")."
                S_LOG_{$Step->POSITION}.id 
                from ns_tracker_{$this->CpId}_stat_log S_LOG_{$Step->POSITION}
                $StepJoinStr
                $StepWhereStr
            )

            group by pq.id
            order by CNT desc
            limit 10
        ";
        $Query = preg_replace("/[\t ]+/"," ",$Query);
        return $Query;
    }

    function GetStepReturns($Step) 
    {
        $JoinStr = $WhereStr = $StepJoinStr = $StepWhereStr = '';
        $JoinArr = $WhereArr = $SteJoinArr = $StepWhereArr = array();

        for($i=1 ; $i<$Step->POSITION; $i++) {
            $JoinArr = array_merge($JoinArr,$this->Steps[$i]->Q['JoinArr']);
            $JoinArr = array_merge($JoinArr,$this->Steps[$i]->Q['CmnJoin'],$this->Steps[$i]->Q['OutsCmnJoin']);
            $WhereArr = array_merge($WhereArr,$this->Steps[$i]->Q['WhereArr']);
            $WhereArr = array_merge($WhereArr,$this->Steps[$i]->Q['CntWhere']);
        }
        $WhereArr=array_unique($WhereArr);
        $JoinArr=array_unique($JoinArr);

        $StepJoinArr = $this->Steps[$Step->POSITION]->Q['CmnJoin'];
        $StepWhereArr = $this->Steps[$Step->POSITION]->Q['WhereArr'];
        $StepWhereArr = array_merge($StepWhereArr,$this->Steps[$i]->Q['OutsWhere']);
        $StepJoinArr=array_unique($StepJoinArr);
        $StepWhereArr=array_unique($StepWhereArr);

        $JoinStr=(!empty($JoinArr))?implode("\n",$JoinArr):"";
        $WhereStr=(!empty($WhereArr))?"WHERE ".implode("\nAND ",$WhereArr):"";        
        $StepJoinStr=(!empty($StepJoinArr))? implode("\n",$StepJoinArr):"";
        $StepWhereStr=(!empty($StepWhereArr))?"WHERE ".implode("\nAND ",$StepWhereArr):"";                

        $Query = "
            select
            concat('http://', sh.HOST, sp.PATH, IF( q.QUERY_STRING IS NOT NULL, concat(?mark, q.QUERY_STRING ) , '')) as PATH,
            count(distinct s1.visitor_id) as CNT
            from ?_{$this->CpId}_stat_log S_LOG_1

            $JoinStr

            inner join ?_{$this->CpId}_stat_session_log slog1 on slog1.prev_log_id = S_LOG_".($Step->POSITION-1).".id
            inner join ?_{$this->CpId}_stat_log s1 on s1.id = slog1.log_id
            inner join ?_page_query pq
                on pq.site_host_id = s1.site_host_id
              and pq.page_id = s1.page_id
              and pq.query_id = s1.query_id
            inner join ?_site_page sp on sp.id = pq.page_id
            inner join ?_site_host sh on sh.id = pq.site_host_id
            left join ?_query q on q.id=pq.query_id

            $WhereStr
            and exists (
                select ".($this->Steps[$Step->POSITION]->OutsUseValue?"":"straight_join")."
                S_LOG_{$Step->POSITION}.id 
                from ns_tracker_{$this->CpId}_stat_log S_LOG_{$Step->POSITION}
                $StepJoinStr
                $StepWhereStr
                and S_LOG_{$Step->POSITION}.id != s1.id
            )

            group by pq.id
            order by CNT desc
            limit 10
        ";
        $Query = preg_replace("/[\t ]+/"," ",$Query);
        return $Query;
    }

    function ClearQueryParts($Arr)
    {
        foreach ($Arr as $i=>$Str) {
            $Str = preg_replace("/[\r\n]/","",trim($Str));
            $Str = preg_replace("/[\s]+/"," ",$Str);
            $Arr[$i]=$Str;
        }
        return $Arr;
    }

    function UserCache()
    {
        global $Db,$nsUser;
        $Stamp=gmdate("Y-m-d H:i:s", time());
        $FunnelId=(isset($this->FunnelId)&&$this->FunnelId)?$this->FunnelId:0;
        $Query = "INSERT INTO ?_user_cache (CACHE_ID, USER_ID, STAMP, FUNNEL_ID, COMPANY_ID) 
                            VALUES (?,?,?,?,?)";
        $Db->Query($Query, $this->CacheId, $nsUser->UserId(), $Stamp, $FunnelId, $this->CpId);
        $Query = "DELETE FROM ?_user_cache WHERE STAMP <= DATE_ADD('$Stamp', INTERVAL -1 MONTH)";
        $Db->Query($Query);
    }
}
?>