<?


class SearchEngine 
{

    function SearchEngine($RefInfo=false)
    {
        $this->XmlLoaded=false;
        $this->XMLData=array();
        $this->LoadXmlData();
        $this->SetReferer($RefInfo);
    }

    function SetReferer($RefInfo=false)
    {
        $this->Host=false;
        $this->QArr=array();
        $this->Referer=false;
        if (is_array($RefInfo)) {
            $this->Referer=@$RefInfo['referer'];
            $this->Host=$RefInfo['host'];
            $this->QArr=is_array(@$RefInfo['query'])?$RefInfo['query']:$this->ParseQuery(@$RefInfo['query']);
        }
        else {
            $this->Referer=$RefInfo;
            $this->ParseRef($RefInfo);
        }
        $this->HostGrpKey=false;
        $this->Keyword=false;        
    }

    function AnalyzeData()
    {
        if (empty($this->XMLData)) return false;
        if ($this->HostGrpKey && !isset($this->XMLData[$this->HostGrpKey])) return false;
        if ($this->HostGrpKey) $List=array($this->HostGrpKey=>@$this->XMLData[$this->HostGrpKey]);
        else $List=&$this->XMLData;
        foreach ($List as $Key=>$Arr) { 
            if (@$Arr['reg'] && !preg_match($Arr['reg'],$this->Host)) continue;
            if (@$Arr['reg_not'] && preg_match($Arr['reg_not'],$this->Host)) continue;
            $this->HostGrpKey=$Key;

            if (@$Arr['keyreg']) {
                $Res=array();
                preg_match($Arr['keyreg'],urldecode($this->Referer),$Res);
                $this->Keyword=@$Res[1];
            }

            if (@$Arr['keyparam'] && ($K=@$this->QArr[ $Arr['keyparam'] ])) $this->Keyword=urldecode($K);
            return $this->HostGrpKey;
        }
        return false;
    }

    function ParseRef($Referer='')
    {
        if (!strpos($Referer,"?")) $Referer=urldecode($Referer);
        $Arr=@parse_url($Referer);
        if (!@$Arr['host']) return false;
        $Arr['host']=strtolower($Arr['host']);
        if ($Arr['host']=='pagead2.googlesyndication.com') {
            $QueryArr=$this->ParseQuery($Arr['query']);
            if (isset($QueryArr['url'])) return $this->ParseRef($QueryArr['url']);
        }
        $QueryArr=$this->ParseQuery(@$Arr['query']);
        $this->Host=$Arr['host'];
        $this->QArr=$QueryArr;        
    }

    function ParseQuery($QS='') 
    {
        $QArr=array();
        if (!$QS) return $QArr;
        $QS=str_replace("?", "", $QS);
        parse_str($QS, $QArr);
        if (!empty($QArr)&&get_magic_quotes_gpc()) $this->strip_request_slashes($QArr);
        return $QArr;
    }

    function LoadXmlData() {
        if ($this->XmlLoaded) return false;
        global $Db, $_NS_TRACK_VARS;
        if (isset($_NS_TRACK_VARS['Db'])) $Db=&$_NS_TRACK_VARS['Db'];
        if (isset($_NS_TRACK_VARS['QueryClass'])) $QueryClass=&$_NS_TRACK_VARS['QueryClass'];
        else $QueryClass='Query';
        $XmlData=false;
        if (!isset($this->XmlDbData)) {
            $this->XmlDbData=array();
            $Query = "SELECT CONTENT FROM ?_xml WHERE FILENAME='search.xml' ";
            $XmlData=$Db->ReturnValue($Query);
        }

        if ($XmlData) {$this->ParseXmlData($XmlData); return $this->XmlLoaded=true;}
        return false;
    }

    function ParseXmlData($XML)
    {
        $Struct=array();
        $p=xml_parser_create();
        xml_parser_set_option($p,XML_OPTION_CASE_FOLDING,0);
        xml_parser_set_option($p,XML_OPTION_SKIP_WHITE,1);
        xml_parse_into_struct($p,$XML,$Struct);
        xml_parser_free($p);        
        if (empty($Struct)) return false;
        $LastLevelKey='';
        $CurrentElement=array();
        foreach ($Struct as $Row) {
            if ($Row['level']==2 && $Row['type']=='close') {
                $this->ParseXmlElement($CurrentElement); $CurrentElement=array(); continue;}
            if ($Row['type']=='close') continue;
            if ($Row['level']==3) $CurrentElement[$Row['tag']]=trim(@$Row['value']);
        }
    }

    function ParseXmlElement($Elem=array())
    {
        if (empty($Elem)) return false;
        $this->XMLData[$Elem['key']]=$Elem;
    }    

    function strip_request_slashes(&$request){
        foreach($request as $key => $val){
            if(!is_array($request[$key]))$request[$key] = stripslashes($val);
            else $this->strip_request_slashes($request[$key]);
        }
    }    
}

?>