<?
require_once SELF."/class/report_parent_v2.class.php";

class SplitStat_v2 extends ReportParent
{
	var $SplitId;
	var $StartDate;
	var $EndDate;
	var $ViewDate;

	var $SelectArr;
	var $JoinArr;
	var $GroupArr;
	var $WhereArr;
	var $OrderArr;

	var $ShowPages;

	function SplitStat_v2($CpId=0)
	{
        $this->ReportParent($CpId);     
        $this->CpId=$CpId;    
        $this->GetSettings();       
		$this->SplitId=false;
		$this->StartDate=false;
		$this->EndDate=false;
		$this->ViewDate=false;

		$this->_GetVisits=false;
		$this->_GetActions=false;
		$this->_GetSales=false;
		$this->_GetActionConv=false;
		$this->_GetSaleConv=false;

		$this->SelectArr=array();
		$this->JoinArr=array();
		$this->GroupArr=array();
		$this->WhereArr=array();
		$this->OrderArr=array();

		$this->ShowPages=false;

		$this->Db=&$GLOBALS['Db'];
		$this->ProcessTime=0;
		$this->SplitStat=array();
		$this->PageStat=array();
		$this->CookieJoin=true;
		$this->GrpFld=false;
		$this->GrpName=false;

		$this->UseStraight=false;

        $this->Mode='SPLIT';
	}

    //      
    //     
    function CollectCacheParams()
    {
        global $ViewDate, $StartDate, $EndDate, $DynamicPeriod;
        $this->QueryParams['ViewDate']=(string) $ViewDate;
        $this->QueryParams['StartDate']=(string) $StartDate;
        $this->QueryParams['EndDate']=(string) $EndDate;
        $this->QueryParams['DynamicPeriod']=(string) $DynamicPeriod;
        $this->QueryParams['SplitId']=(string) $this->SplitId;
    }

    function CacheJob($Params=false)
    {
        if ($this->CacheJobLaunched) return false;
        $this->CacheJobLaunched=true;     
        global $Logs, $nsUser, $Db;
        $this->GetSettings();
        $Return=false;
        
        //   ,      
        if (empty($this->QueryParams)) $this->CollectCacheParams();
        
        // ,        
        if (isset($this->QueryParams['Filter'])&&$this->QueryParams['Filter']&&$this->FindCacheWithoutLimit()) {
            $this->QueryParams['Filter']="";
            $this->FilterOnFly=true;
        }
        
        //     
        $this->QueryParams=$this->RemoveExcess($this->QueryParams);

        $this->GetQuerySetId();
        // ,     
        if ($this->CacheEnable&&$this->CacheSmart) $this->CacheNeed=$this->CheckCacheNeed();

        //     
        //   ,  smart  
        if ( ($this->CacheEnable && $this->CacheNeed) || ($this->CacheEnable && !$this->CacheSmart)) {
            $Return=true;
            $this->GetCacheId();
            if ($this->CacheId && $this->CacheAgeLimitExceed) return $this->NoCache(); 
            if (!$this->CacheId) $this->CreateCacheRecord();
            if ($this->CacheId) {
                if ($this->HasData()) {
                    $this->StatArr=$this->GetData();
                    $this->SplitStat=ValidVar($this->StatArr[0]);
                    if ($this->SplitStat) $this->SplitStat=unserialize($this->SplitStat);
                    $this->PageStat=ValidVar($this->StatArr[1]);
                    if ($this->PageStat) $this->PageStat=unserialize($this->PageStat);                    
                    $this->TakenFromCache=true;
                    if (isset($nsUser->CacheArr[$this->CacheId])) {
                        unset($nsUser->CacheArr[$this->CacheId]);
                        $nsUser->REPORTS_DONE--;
                        $Query = "UPDATE ?_user_cache SET DONE=2 WHERE CACHE_ID=? AND DONE=1";
                        $Db->Query($Query, $this->CacheId);
                    }
                }
                else {
                    if (!$this->ToCache && $this->CacheUpdateMode==1) $this->AddToCache();
                    $this->NonRealTime=true;
                }
            }
        }

        return $Return;
    }


	function Calculate($Mode="")
	{
		global $nsUser, $CurrentCompany;
        if (!in_array($Mode, array("EXPLAIN", "QUERY")) && $this->CacheEnable && $this->CacheJob()) return false;
        
		if (ValidId($CurrentCompany->ID)&&$CurrentCompany->SITE_CNT==0&&$this->CpId==$CurrentCompany->ID) return false;
		$this->StartTime=$this->GetMicrotime();

		if ($this->_GetActionConv) {
			$this->_GetVisits=true;
			$this->_GetActions=true;
		}
		if ($this->_GetSaleConv) {
			$this->_GetVisits=true;
			$this->_GetSales=true;
		}

		$this->Where();
		$this->SplitStat=$this->GetStat($Mode);
        if ($Mode=="EXPLAIN") return false;
        if ($Mode=="QUERY") return $this->SplitStat;
        

		if ($this->ShowPages) {
            $this->SelectArr[]="PQ.ID AS SPLIT_PAGE";
            $this->SelectArr[]="IF(S_LOG.QUERY_ID>0, CONCAT(SP.PATH, '?', TQ.QUERY_STRING), SP.PATH) AS PATH";
            $this->SelectArr[]="TQ.QUERY_STRING";
            $this->SelectArr[]="SH.HOST";
            $this->GroupArr[]="PQ.ID";
            $this->GrpFld="SPLIT_PAGE";
            $this->GrpName="PATH";
            $this->JoinArr[]="INNER JOIN ?_page_query PQ USE INDEX(TRIPLE2) ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID";
            $this->JoinArr[]="INNER JOIN ?_site_page SP ON SP.ID=S_LOG.PAGE_ID";
            $this->JoinArr[]="INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID";
            $this->JoinArr[]="LEFT JOIN ?_query TQ ON TQ.ID = S_LOG.QUERY_ID";
            $this->PageStat=$this->GetStat();
		}

		$this->EndTime=$this->GetMicrotime();
		$this->ProcessTime=$this->EndTime-$this->StartTime;

	}

	function Where()
	{
		global $nsUser;
		//    
		$StartStamp=false;
		$EndStamp=false;
        if (strpos($this->StartDate, " ")!==false) {
            $StartStamp=$this->StartDate;
            $this->StartDate="";
        }
        if (strpos($this->EndDate, " ")!==false) {
            $EndStamp=$this->EndDate;
            $this->EndDate="";
        }

		if (ValidDate($this->ViewDate)) {
			$StartStamp=$this->ViewDate." 00:00:00";
			$EndStamp=$this->ViewDate." 23:59:59";
		}
		if (ValidDate($this->StartDate)) $StartStamp=$this->StartDate." 00:00:00";
		if (ValidDate($this->EndDate)) $EndStamp=$this->EndDate." 23:59:59";
		if ($StartStamp&&$EndStamp) $this->WhereArr[]="S_LOG.STAMP BETWEEN DATE_ADD('$StartStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE) AND DATE_ADD('$EndStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
		if ($StartStamp&&!$EndStamp) $this->WhereArr[]="S_LOG.STAMP >= DATE_ADD('$StartStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
		if (!$StartStamp&&$EndStamp) $this->WhereArr[]="S_LOG.STAMP <= DATE_ADD('$EndStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";

        $this->StartStamp=$StartStamp;
        $this->EndStamp=$EndStamp;

		if (ValidId($this->SplitId)) $this->WhereArr[]="S_SPLIT.SPLIT_ID = ".$this->SplitId;
	}

	function GetStat($Mode="")
	{

		global $Logs;
		$StatArr=array();
		$GrpItems=array();
		$GrpList="";
		$SelectStr="";
		$JoinStr="";
		$OrderStr="";
		$GroupStr="";
		$WhereStr="";
		$StraightStr="";
		$LimitStr="";
        // SQL_CALC_FOUND_ROWS is a temp hack to fix a problem with LIMIT on 
        // MySQL 4.1.21 (it is only supported from MySQL 4.0)
        //if (count($this->SelectArr)>0) $SelectStr="SQL_CALC_FOUND_ROWS\n".implode(", \n", $this->SelectArr).", \n";        
		if (count($this->SelectArr)>0) $SelectStr=implode(", ", $this->SelectArr).", ";
		if (count($this->JoinArr)>0) $JoinStr=implode(" \n", $this->JoinArr);
		if (count($this->OrderArr)>0) $OrderStr="ORDER BY ".implode(", ", $this->OrderArr);
		if (count($this->GroupArr)>0) $GroupStr="GROUP BY ".implode(", ", $this->GroupArr);
		if (count($this->WhereArr)>0) $WhereStr="WHERE ".implode(" AND ", $this->WhereArr);
		if ($this->UseStraight) $StraightStr="STRAIGHT_JOIN";

		///////////////////////////////////////////
		//  
		if ($this->_GetVisits) {
			$Query = "
				SELECT  $StraightStr
					$SelectStr
					COUNT(S_LOG.ID) CNT,
					COUNT(DISTINCT S_LOG.VISITOR_ID) UNI
					#     
					FROM ?_{$this->CpId}_stat_log S_LOG
					#      
					# ,   referer set 
					#JOIN ?_stat_path S_PATH
					#	ON S_PATH.LOG_ID=S_LOG.ID
					INNER JOIN ?_{$this->CpId}_stat_split S_SPLIT
						ON S_SPLIT.LOG_ID=S_LOG.ID
				$JoinStr
				$WhereStr
				$GroupStr
				$OrderStr
				$LimitStr
			";

            if ($Mode=="EXPLAIN") {
                $this->GetQueryExplain($Query, 0);
                return false;
            }
            if ($Mode=="QUERY") return $Query;
            
            $Sql = new Query($Query);
			while ($Row=$Sql->Row()) {
				//    ,   
				if ($this->GrpFld) {$Tmp=$this->GrpFld;$Grp=$Row->$Tmp;}
				else $Grp=$Sql->Position; // ,   
				//  ,    ,    
				if ($this->GrpName) {$Name=$this->GrpName; $Row->$Name=trim($Row->$Name); $StatArr[$Grp]['Name']=$Row->$Name;}
				$StatArr[$Grp]['CntClick']=$Row->CNT or 0;
				$StatArr[$Grp]['UniClick']=$Row->UNI or 0;
				$StatArr[$Grp]['CntAction']=0;
				$StatArr[$Grp]['UniAction']=0;
				$StatArr[$Grp]['CntSale']=0;
				$StatArr[$Grp]['UniSale']=0;
				$StatArr[$Grp]['Income']=0;
                $StatArr[$Grp]['ActionConv']=0;
                $StatArr[$Grp]['SaleConv']=0;
				$StatArr[$Grp]['Obj']=$Row;
				//  ID ,   
				//         
				if (count($this->GroupArr)) $GrpItems[]=$Grp;
			}
            $this->QuerySetLog($Sql->ResTime, false,$Query, 0);
			if (count($GrpItems)>0&&!ValidId($this->GroupArr[0])) $GrpList="AND ".$this->GroupArr[0]." IN (".implode(",",$GrpItems).")";
		}
		///////////////////////////////////////////
		//  
		if ($this->_GetActions) {
			//   
			$Query = "
				SELECT  $StraightStr
					$SelectStr
					COUNT(S_LOG.ID) CNT,
					COUNT(DISTINCT S_LOG.VISITOR_ID) UNI
					#     
					FROM ?_{$this->CpId}_stat_log S_LOG
					#   ,    S_LOG.ID
					#  ,   COOKIE_LOG    ID
					INNER JOIN ?_{$this->CpId}_stat_log NODE
						ON NODE.COOKIE_LOG=S_LOG.ID
					#   
					#    
					INNER JOIN ?_{$this->CpId}_stat_action S_ACTION
						ON S_ACTION.LOG_ID=NODE.ID
					#      
					# ,   referer set 
					#JOIN ?_stat_path S_PATH
					#	ON S_PATH.LOG_ID=S_LOG.ID
					INNER JOIN ?_{$this->CpId}_stat_split S_SPLIT
						ON S_SPLIT.LOG_ID=S_LOG.ID
				$JoinStr
				$WhereStr
				$GrpList
				$GroupStr
				$OrderStr
				$LimitStr
			";

            if ($Mode=="EXPLAIN") {
                $this->GetQueryExplain($Query, 1);
                return false;
            }
            if ($Mode=="QUERY") return $Query;

			$Sql = new Query($Query);
			while ($Row=$Sql->Row()) {
				if ($this->GrpFld) {$Tmp=$this->GrpFld;$Grp=$Row->$Tmp;}
				else $Grp=$Sql->Position;
				if (!isset($StatArr[$Grp])&&$this->_GetVisits) continue;
				if(!$this->_GetVisits) {
					if ($this->GrpName) {$Name=$this->GrpName; $Row->$Name=trim($Row->$Name); $StatArr[$Grp]['Name']=$Row->$Name;}
				}
				$StatArr[$Grp]['CntAction']=$Row->CNT;
				$StatArr[$Grp]['UniAction']=$Row->UNI;
				$StatArr[$Grp]['Obj']=$Row;
			}
            $this->QuerySetLog($Sql->ResTime, false,$Query, 1);
		}
		///////////////////////////////////////////
		//  
		if ($this->_GetSales) {
			//   
			$Query = "
				SELECT  $StraightStr
					$SelectStr
					COUNT(S_LOG.ID) CNT,
					COUNT(DISTINCT S_LOG.VISITOR_ID) UNI,
					SUM(S_SALE.COST) AS SALE_SUM
					FROM ?_{$this->CpId}_stat_log S_LOG
					INNER JOIN ?_{$this->CpId}_stat_log NODE
						ON NODE.COOKIE_LOG=S_LOG.ID
					INNER JOIN ?_{$this->CpId}_stat_sale S_SALE
						ON S_SALE.LOG_ID=NODE.ID
					#JOIN ?_stat_path S_PATH
					#	ON S_PATH.LOG_ID=S_LOG.ID
					INNER JOIN ?_{$this->CpId}_stat_split S_SPLIT
						ON S_SPLIT.LOG_ID=S_LOG.ID
				$JoinStr
				$WhereStr
				$GrpList
				$GroupStr
				$OrderStr
				$LimitStr
			";

            if ($Mode=="EXPLAIN") {
                $this->GetQueryExplain($Query, 2);
                return false;
            }
            if ($Mode=="QUERY") return $Query;

			$Sql = new Query($Query);
			while ($Row=$Sql->Row()) {
				if ($this->GrpFld) {$Tmp=$this->GrpFld;$Grp=$Row->$Tmp;}
				else $Grp=$Sql->Position;
				if (!isset($StatArr[$Grp])&&$this->_GetVisits) continue;
				if(!$this->_GetVisits) {
					if ($this->GrpName) {$Name=$this->GrpName; $Row->$Name=trim($Row->$Name); $StatArr[$Grp]['Name']=$Row->$Name;}
				}
				$StatArr[$Grp]['CntSale']=$Row->CNT;
				$StatArr[$Grp]['UniSale']=$Row->UNI;
				$StatArr[$Grp]['Income']=$Row->SALE_SUM;
				$StatArr[$Grp]['Obj']=$Row;
			}
            $this->QuerySetLog($Sql->ResTime, false,$Query, 2);
		}


		foreach ($StatArr as $i => $Row) {
			if ($this->_GetActionConv)
				$StatArr[$i]['ActionConv']=$this->GetRatio($StatArr[$i]['UniClick'], $StatArr[$i]['UniAction']);
			if ($this->_GetSaleConv) 
				$StatArr[$i]['SaleConv']=$this->GetRatio($StatArr[$i]['UniClick'], $StatArr[$i]['UniSale']);
			if (!$StatArr[$i]['Income']) $StatArr[$i]['Income']=0;
		}

		if (!ValidArr($StatArr)||count($StatArr)==0) return false;
		if (count($this->GroupArr)<1) {
			if (!isset($Grp)) $Grp=0;
			return $StatArr[$Grp];
		}
		return $StatArr;

	}

}

?>