CREATE TABLE `{PREF}_system_config` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `PRODUCT_ID` int(11) unsigned NOT NULL default '0',
  `PLUGIN_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(128) NOT NULL default '',
  `CALLNAME` varchar(128) NOT NULL default '',
  `DATATYPE` enum('INTVAL','STRVAL','MEMO') NOT NULL default 'INTVAL',
  `INTVAL` int(11) default NULL,
  `STRVAL` varchar(255) default NULL,
  `MEMO` text,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `UNI` (`PRODUCT_ID`,`CALLNAME`),
  KEY `PRODUCT_ID` (`PRODUCT_ID`),
  KEY `PLUGIN_ID` (`PLUGIN_ID`),
  KEY `DATATYPE` (`DATATYPE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_system_plugin` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `PRODUCT_ID` int(11) unsigned NOT NULL default '0',
  `EVENT_NAME` varchar(128) NOT NULL default '',
  `NAME` varchar(128) NOT NULL default '',
  `DESCRIPTION` varchar(255) default NULL,
  `ORD` int(11) default NULL,
  `DIRNAME` varchar(127) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `PRODUCT_ID` (`PRODUCT_ID`),
  KEY `EVENT_NAME` (`EVENT_NAME`)
) Type=MyISAM;


CREATE TABLE `{PREF}_system_product` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME` varchar(128) NOT NULL default '',
  `FOLDER` varchar(128) NOT NULL default '',
  `DEFAULT_LANG` varchar(10) NOT NULL default '',
  `STRT_INT` int(11) unsigned NOT NULL default '0',
  `DEFAULT_SKIN` varchar(128) NOT NULL default '',
  `WHITE_LOGO` varchar(255) NOT NULL default '',
  `VERSION` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_system_user` (
  `ID` int(11) NOT NULL auto_increment,
  `LOGIN` varchar(64) NOT NULL default '',
  `PWD` varchar(255) NOT NULL default '',
  `NAME` varchar(255) default NULL,
  `EMAIL` varchar(255) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `LOGIN` (`LOGIN`),
  KEY `PWD` (`PWD`)
) Type=MyISAM;


CREATE TABLE `{PREF}_system_user2lang` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `UID` int(11) NOT NULL default '0',
  `PROD_ID` int(11) default NULL,
  `LANG` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `UID` (`UID`),
  KEY `PROD_ID` (`PROD_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_system_user2skin` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `UID` int(11) unsigned NOT NULL default '0',
  `PROD_ID` int(11) unsigned NOT NULL default '0',
  `SKIN` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `UID` (`UID`),
  KEY `PROD_ID` (`PROD_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_bot_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `UA_ID` int(11) unsigned NOT NULL default '0',
  `PQ_ID` int(11) unsigned NOT NULL default '0',
  `IP_ID` int(11) unsigned NOT NULL default '0',
  `REFERER_SET` int(11) unsigned NOT NULL default '0',
  `SCHEME` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `STAMP` (`STAMP`),
  KEY `UA_ID` (`UA_ID`),
  KEY `PQ_ID` (`PQ_ID`),
  KEY `IP_ID` (`IP_ID`),
  KEY `REFERER_SET` (`REFERER_SET`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_cache` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `QUERY_SET_ID` int(11) unsigned NOT NULL default '0',
  `LAST_CACHED` datetime NOT NULL default '0000-00-00 00:00:00',
  `LAST_CACHED_TZ` varchar(5) NOT NULL default '',
  `TO_CACHE` enum('0','1') NOT NULL default '0',
  `CACHE_TYPE` tinyint(4) NOT NULL default '0',
  `MODE` varchar(32) NOT NULL default '',
  `UPDATE_INTERVAL` int(11) unsigned NOT NULL default '0',
  `USE_CNT` int(11) unsigned NOT NULL default '0',
  `ADDITIONAL_TASK` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `QUERY_SET_ID` (`QUERY_SET_ID`),
  KEY `DBL` (`QUERY_SET_ID`),
  KEY `TO_CACHE` (`TO_CACHE`),
  KEY `CACHE_TYPE_DBL` (`CACHE_TYPE`,`LAST_CACHED`),
  KEY `MODE` (`MODE`),
  KEY `USE_CNT` (`USE_CNT`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_cache_cron_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `CACHE_ID` int(11) unsigned NOT NULL default '0',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `RUN_TIME` varchar(128) NOT NULL default '0',
  `ERRORS` text NOT NULL,
  `RUN_ID` varchar(32) NOT NULL default '',
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `RUN_MODE` smallint(6) unsigned NOT NULL default '0',
  `CPU_LOAD` double(15,2) unsigned NOT NULL default '0.00',
  `CPU_LOAD_BEFORE` double(15,2) unsigned NOT NULL default '0.00',
  `MESSAGE` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `RUN_ID` (`RUN_ID`),
  KEY `STAMP` (`STAMP`),
  KEY `RUN_TIME` (`RUN_TIME`),
  KEY `CPU_LOAD` (`CPU_LOAD`),
  KEY `CPU_LOAD_BEFORE` (`CPU_LOAD_BEFORE`),
  KEY `CACHE_ID` (`CACHE_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_cache_data` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `CACHE_ID` int(11) unsigned NOT NULL default '0',
  `FULL_DATA` longtext,
  `ROWS_CNT` int(11) unsigned NOT NULL default '0',
  `LIMIT_EXCEED` tinyint(4) unsigned NOT NULL default '0',
  `ADDITIONAL` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `CACHE_ID` (`CACHE_ID`),
  KEY `ADDITIONAL` (`ADDITIONAL`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_cache_popularity` (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `CACHE_ID` int(11) unsigned NOT NULL default '0',
  `ADDITIONAL_TASK` varchar(255) NOT NULL default '',
  `ADDITIONAL` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `STAMP` (`STAMP`),
  KEY `CACHE_ID` (`CACHE_ID`),
  KEY `ADDITIONAL` (`ADDITIONAL`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_cache_query_set` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `MD5_SEARCH` varchar(32) NOT NULL default '',
  `PARAMS_SET` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `MD5_SEARCH` (`MD5_SEARCH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_delayed` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REQUEST_TYPE` tinyint(4) unsigned NOT NULL default '0',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `VISITOR_COOKIE` varchar(32) NOT NULL default '',
  `IP` varchar(15) NOT NULL default '',
  `BOT_LOG` tinyint(4) unsigned NOT NULL default '0',
  `VARS` text NOT NULL,
  `COOKIE_VARS` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `REQUEST_TYPE` (`REQUEST_TYPE`),
  KEY `STAMP` (`STAMP`),
  KEY `IP` (`IP`),
  KEY `VISITOR_COOKIE` (`VISITOR_COOKIE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_action` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `LOG_ID` int(11) unsigned NOT NULL default '0',
  `ACTION_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `LOG_ID` (`LOG_ID`),
  KEY `ACTION_ID` (`ACTION_ID`),
  KEY `SITE_ID` (`SITE_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_click` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `LOG_ID` int(11) unsigned NOT NULL default '0',
  `KEYWORD_ID` int(11) unsigned NOT NULL default '0',
  `CAMP_ID` int(11) unsigned NOT NULL default '0',
  `SOURCE_HOST_ID` int(11) unsigned NOT NULL default '0',
  `FRAUD` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `LOG_ID` (`LOG_ID`),
  KEY `KEYWORD_ID` (`KEYWORD_ID`),
  KEY `CAMP_ID` (`CAMP_ID`),
  KEY `SOURCE_HOST_ID` (`SOURCE_HOST_ID`),
  KEY `FRAUD` (`FRAUD`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `VISITOR_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `SITE_HOST_ID` int(11) unsigned NOT NULL default '0',
  `COOKIE_LOG` int(11) unsigned NOT NULL default '0',
  `PAGE_ID` int(11) unsigned NOT NULL default '0',
  `QUERY_ID` int(11) unsigned NOT NULL default '0',
  `REFERER_SET` int(11) unsigned NOT NULL default '0',
  `IP_ID` int(11) unsigned NOT NULL default '0',
  `AGENT_ID` int(11) unsigned NOT NULL default '0',
  `SCHEME` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `VISITOR_ID` (`VISITOR_ID`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `COOKIE_LOG` (`COOKIE_LOG`),
  KEY `DBL_1` (`SITE_ID`,`STAMP`),
  KEY `PAGE_ID` (`PAGE_ID`),
  KEY `QUERY_ID` (`QUERY_ID`),
  KEY `REFERER_SET` (`REFERER_SET`),
  KEY `SITE_HOST_ID` (`SITE_HOST_ID`),
  KEY `AGENT_ID` (`AGENT_ID`),
  KEY `IP_ID` (`IP_ID`),
  KEY `STAMP` (`STAMP`),
  KEY `QUERY_TRIPLE` (`SITE_HOST_ID`,`PAGE_ID`,`QUERY_ID`),
  KEY `NO_REF_TRIPLE` (`VISITOR_ID`,`SITE_HOST_ID`,`STAMP`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_sale` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `LOG_ID` int(11) unsigned NOT NULL default '0',
  `COST` float(9,2) unsigned NOT NULL default '0.00',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `CUSTOM_ORDER_ID` varchar(64) NOT NULL default '',
  `ADDITIONAL` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `LOG_ID` (`LOG_ID`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `CUSTOM_ORDER_ID` (`CUSTOM_ORDER_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_session` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `START_LOG_ID` int(11) unsigned NOT NULL default '0',
  `END_LOG_ID` int(11) unsigned NOT NULL default '0',
  `FIRST_SESSION` tinyint(4) unsigned NOT NULL default '0',
  `VISITOR_ID` int(11) unsigned NOT NULL default '0',
  `VISIT_LENGTH` int(11) unsigned NOT NULL default '0',
  `VISIT_DEPTH` int(11) unsigned NOT NULL default '1',
  `VISIT_PATH` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `DBL2` (`ID`,`FIRST_SESSION`),
  UNIQUE KEY `DBL` (`START_LOG_ID`,`END_LOG_ID`),
  KEY `START_LOG_ID` (`START_LOG_ID`),
  KEY `FIRST_SESSION` (`FIRST_SESSION`),
  KEY `VISIT_LENGTH` (`VISIT_LENGTH`),
  KEY `VISIT_DEPTH` (`VISIT_DEPTH`),
  KEY `VISIT_PATH` (`VISIT_PATH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_session_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SESSION_ID` int(11) unsigned NOT NULL default '0',
  `LOG_ID` int(11) unsigned NOT NULL default '0',
  `PREV_LOG_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `SESSION_ID` (`SESSION_ID`),
  KEY `LOG_ID` (`LOG_ID`),
  KEY `PREV_LOG_ID` (`PREV_LOG_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_session_path` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SESSION_ID` int(11) unsigned NOT NULL default '0',
  `PATH` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `SESSION_ID` (`SESSION_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_split` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `LOG_ID` int(11) unsigned NOT NULL default '0',
  `SPLIT_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `LOG_ID` (`LOG_ID`),
  KEY `SPLIT_ID` (`SPLIT_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_stat_undef` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `ADDRESS` varchar(255) NOT NULL default '',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `IP_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `ADDRESS` (`ADDRESS`),
  KEY `STAMP` (`STAMP`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `IP_ID` (`IP_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_static_archive_cache` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `PERIOD_ID` int(11) unsigned NOT NULL default '0',
  `CACHE_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) NOT NULL default '0',
  `NEXT_ARCHIVE_START_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `NEXT_ARCHIVE_END_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ID`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `CACHE_ID` (`CACHE_ID`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `PERIOD_ID` (`PERIOD_ID`),
  KEY `NEXT_ARCHIVE_START_DATE` (`NEXT_ARCHIVE_START_DATE`),
  KEY `NEXT_ARCHIVE_END_DATE` (`NEXT_ARCHIVE_END_DATE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_1_static_report_cache` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `PERIOD_ID` int(11) unsigned NOT NULL default '0',
  `CACHE_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `CACHE_ID` (`CACHE_ID`),
  KEY `DBL` (`REPORT_ID`,`CACHE_ID`),
  KEY `PERIOD_ID` (`PERIOD_ID`),
  KEY `DBL2` (`REPORT_ID`,`PERIOD_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_action_item` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `NAME` (`NAME`),
  KEY `COMPANY_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_action_set` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `STAT_ACTION_ID` int(11) unsigned NOT NULL default '0',
  `ACTION_ITEM_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `STAT_ACTION_ID` (`STAT_ACTION_ID`),
  KEY `ACTION_ITEM_ID` (`ACTION_ITEM_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_admin` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `SUPER_ADMIN` enum('1','0') NOT NULL default '0',
  `MODIFIED` timestamp NOT NULL,
  `DEMO` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `USER_ID` (`USER_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_archive` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) NOT NULL default '0',
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `START_DATE` date NOT NULL default '0000-00-00',
  `END_DATE` date NOT NULL default '0000-00-00',
  `PERIOD` varchar(32) NOT NULL default '',
  `FULL_DATA` longtext,
  `TIMEZONE` varchar(5) NOT NULL default '',
  `PARAMS_SET` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `DBL1` (`START_DATE`,`END_DATE`),
  KEY `DBL2` (`COMPANY_ID`,`REPORT_ID`),
  KEY `PERIOD` (`PERIOD`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `TRIPLE` (`COMPANY_ID`,`REPORT_ID`,`PERIOD`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_camp_cost` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SUB_CAMPAIGN` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) default NULL,
  `START_DATE` date default NULL,
  `END_DATE` date default NULL,
  `COST` float(9,2) unsigned NOT NULL default '0.00',
  `SUM_THIS` enum('1','0') NOT NULL default '1',
  `MODE` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `SUB_CAMPAIGN` (`SUB_CAMPAIGN`),
  KEY `START_DATE` (`START_DATE`),
  KEY `END_DATE` (`END_DATE`),
  KEY `SUM_THIS` (`SUM_THIS`),
  KEY `MODE` (`MODE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_camp_piece` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `CAMPAIGN_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` text,
  `POSITION` smallint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `CAMPAIGN_ID` (`CAMPAIGN_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_campaign` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `PARENT_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` text,
  `POSITION` smallint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `PARENT_ID` (`PARENT_ID`),
  KEY `MERCHANT_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_city` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME` varchar(255) NOT NULL default '',
  `COUNTRY_ID` int(11) unsigned NOT NULL default '0',
  `LATITUDE` double(15,4) NOT NULL default '0.0000',
  `LONGITUDE` double(15,4) NOT NULL default '0.0000',
  `AREA_CODE` varchar(32) default NULL,
  `DMA_CODE` varchar(32) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `COUNTRY_ID` (`COUNTRY_ID`),
  KEY `COORDS` (`LATITUDE`,`LONGITUDE`),
  KEY `AREA_CODE` (`AREA_CODE`),
  KEY `DMA_CODE` (`DMA_CODE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_client` (
  `ID` int(11) NOT NULL auto_increment,
  `NAME` varchar(128) NOT NULL default '',
  `DESCRIPTION` text,
  `MODIFIED` timestamp NOT NULL,
  `HIDDEN` enum('1','0') NOT NULL default '0',
  `CURRENCY` varchar(64) NOT NULL default '',
  `CURRENCY_POSITION` enum('0','1') NOT NULL default '0',
  `MAX_SITES` int(11) unsigned NOT NULL default '0',
  `ALLOW_PHP_TRACKING` enum('0','1') NOT NULL default '0',
  `DISABLE_CONSTRUCTOR` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `HIDDEN` (`HIDDEN`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_client_visitor` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `VISITOR_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `CLIENT_ID` (`COMPANY_ID`),
  KEY `VISITOR_ID` (`VISITOR_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_client_visitor_grp` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` text NOT NULL,
  PRIMARY KEY  (`ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_client_visitor_grp_ip` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `GRP_ID` int(11) unsigned NOT NULL default '0',
  `IP` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `GRP_ID` (`GRP_ID`),
  KEY `IP` (`IP`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_client_visitor_ip` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `CLIENT_VISITOR_ID` int(11) unsigned NOT NULL default '0',
  `IP` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `CLIENT_VISITOR_ID` (`CLIENT_VISITOR_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_config` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `KEEP_VISITOR_PATH` enum('0','1','2') NOT NULL default '2',
  `KEEP_NO_REF` enum('0','1','2') NOT NULL default '2',
  `TIME_DBL_PAGE_LOAD` int(11) unsigned NOT NULL default '0',
  `TIME_DBL_ADV_CLICK` int(11) unsigned NOT NULL default '0',
  `TIME_DBL_EVENT` int(11) unsigned NOT NULL default '0',
  `TIME_DBL_SALE` int(11) unsigned NOT NULL default '0',
  `STOP_DBL_PAGE_LOAD` enum('0','1','2') NOT NULL default '2',
  `STOP_DBL_ADV_CLICK` enum('0','1','2') NOT NULL default '2',
  `STOP_DBL_EVENT` enum('0','1','2') NOT NULL default '2',
  `STOP_DBL_SALE` enum('0','1','2') NOT NULL default '2',
  `AGENTS_LAST_UPDATED` datetime NOT NULL default '0000-00-00 00:00:00',
  `ALLOW_SEND_INFO` enum('0','1') NOT NULL default '0',
  `SSL_LINK` text NOT NULL,
  `USE_STORE` enum('0','1') NOT NULL default '0',
  `FROM_EMAIL` varchar(128) NOT NULL default '',
  `ONLINE_PERIOD` smallint(6) unsigned NOT NULL default '0',
  `IP_TRACKING` enum('0','1') NOT NULL default '1',
  `IP_PERIOD` int(11) unsigned NOT NULL default '1',
  `IP_NO_COOKIE` enum('0','1') NOT NULL default '1',
  `FRAUD_ENABLE` enum('0','1') NOT NULL default '0',
  `VAR_CAMPAIGN` varchar(32) NOT NULL default '',
  `VAR_CAMPAIGN_SOURCE` varchar(32) NOT NULL default '',
  `FRAUD_COUNT` int(11) unsigned NOT NULL default '5',
  `FRAUD_PERIOD` int(11) unsigned NOT NULL default '1',
  `VAR_KW` varchar(32) NOT NULL default '',
  `VAR_KEYWORD` varchar(32) NOT NULL default '',
  `WHITE_NO_LOGO` enum('0','1') NOT NULL default '0',
  `WHITE_NO_COPY` enum('0','1') NOT NULL default '0',
  `TRACKING_MODE` varchar(128) NOT NULL default '',
  `CATCH_CHARSET` enum('0','1') NOT NULL default '0',
  `STOP_TRACKING` tinyint(4) unsigned NOT NULL default '0',
  `SHOW_PAGE_TITLE` tinyint(3) unsigned NOT NULL default '0',
  `CACHE_DYNAMIC_ENABLE` tinyint(3) unsigned NOT NULL default '0',
  `CACHE_SMART_ENABLE` tinyint(3) unsigned NOT NULL default '0',
  `CACHE_CLEAN_TIME` int(11) NOT NULL default '0',
  `CACHE_AJAX` tinyint(3) unsigned NOT NULL default '0',
  `CACHE_ROWS_CNT` int(11) unsigned NOT NULL default '0',
  `CACHE_SMART_TIME` int(11) unsigned NOT NULL default '0',
  `CACHE_POPULAR_CNT` int(11) unsigned NOT NULL default '0',
  `CRON_ENABLE` smallint(6) unsigned NOT NULL default '0',
  `CRON_MAX_CPU` varchar(20) NOT NULL default '1',
  `CRON_INTERVAL` smallint(6) unsigned NOT NULL default '0',
  `TIMEZONE` varchar(5) NOT NULL default '',
  `CACHE_UPDATE_TIME` text NOT NULL,
  `CACHE_POPULAR_PERIOD` char(1) NOT NULL default 'd',
  `CPU_AVG_PATH` text NOT NULL,
  `SESSION_BREAK_TIME` int(11) unsigned NOT NULL default '0',
  `DELETE_ENABLE` tinyint(3) unsigned NOT NULL default '0',
  `DELETE_RUN_NOW` tinyint(3) unsigned NOT NULL default '0',
  `DELETE_FUNCS` varchar(255) NOT NULL default '',
  `DELETE_SUB_FUNCS` varchar(255) NOT NULL default '',
  `DELETE_RUN_PERIOD` varchar(32) NOT NULL default '',
  `DELETE_KEEP_PERIOD` varchar(32) NOT NULL default '',
  `DELETE_RANGE_START` date default NULL,
  `DELETE_RANGE_END` date default NULL,
  `DELETE_NEXT_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `ARCHIVE_ENABLE` tinyint(3) unsigned NOT NULL default '0',
  `SALE_ONLY_EXISTING` tinyint(3) unsigned NOT NULL default '0',
  `FORMAT_DATE` varchar(64) NOT NULL default '',
  `FORMAT_TIME` varchar(64) NOT NULL default '',
  `CACHE_SMART_KEEP_DAYS` int(11) unsigned NOT NULL default '0',
  `CRON_SKIP_TIME` text NOT NULL,
  `DELAYED_TRACKING` tinyint(3) unsigned NOT NULL default '0',
  `DEFAULT_PERIOD` varchar(10) NOT NULL default '',
  `CACHE_AUTO_ENABLE` tinyint(3) unsigned NOT NULL default '0',
  `IGNORE_ALL_BOTS` tinyint(3) unsigned NOT NULL,
  `ARCHIVE_ROWS` int(11) unsigned NOT NULL,
  `AUTH_KEY` varchar(128) NOT NULL default '',
  `RSS_ROWS` int(11) unsigned NOT NULL default '200',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `UNI` (`COMPANY_ID`,`SITE_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `SITE_ID` (`SITE_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_const_group` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `CONST_TYPE` enum('NATURAL','PAID') NOT NULL default 'NATURAL',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `KEY_NAME` varchar(32) NOT NULL default '',
  `POSITION` smallint(6) unsigned NOT NULL default '0',
  `ORDER_BY` enum('0','CNT','UNI','NAME','SALECNT','SALEUNI','ACTIONCNT','ACTIONUNI','ACTCONV','SALECONV','ROI','COST','INCOME') NOT NULL default '0',
  `ORDER_TO` enum('0','ASC','DESC') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `CONST_TYPE` (`CONST_TYPE`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `KEY_NAME` (`KEY_NAME`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_country` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `CODE` char(3) NOT NULL default '',
  `NAME` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `CODE` (`CODE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_country_ip` (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `COUNTRY_CODE` char(3) NOT NULL default '',
  `IP_START` int(11) unsigned NOT NULL default '0',
  `IP_END` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `COUNTRY_CODE` (`COUNTRY_CODE`),
  KEY `IP_START` (`IP_START`),
  KEY `IP_END` (`IP_END`),
  KEY `DBL` (`IP_START`,`IP_END`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_cron_archive_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `TASK_PROCESS_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `START_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `END_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `ERRORS` text NOT NULL,
  `CPU_LOAD_BEFORE` double(15,2) unsigned NOT NULL default '0.00',
  `CPU_LOAD` double(15,2) unsigned NOT NULL default '0.00',
  `MESSAGE` varchar(255) NOT NULL default '',
  `RUN_TIME` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `TASK_PROCESS_ID` (`TASK_PROCESS_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `STAMP` (`STAMP`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `MESSAGE` (`MESSAGE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_cron_delete_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `TASK_PROCESS_ID` int(11) unsigned NOT NULL default '0',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `DELETED_ROWS` int(11) unsigned NOT NULL default '0',
  `ERRORS` text NOT NULL,
  `CPU_LOAD_BEFORE` double(15,2) unsigned NOT NULL default '0.00',
  `CPU_LOAD` double(15,2) unsigned NOT NULL default '0.00',
  `MESSAGE` varchar(255) NOT NULL default '0',
  `RUN_TIME` varchar(128) NOT NULL default '',
  `DELETED_SPACE` double(15,2) unsigned NOT NULL default '0.00',
  PRIMARY KEY  (`ID`),
  KEY `TASK_PROCESS_ID` (`TASK_PROCESS_ID`),
  KEY `STAMP` (`STAMP`),
  KEY `MESSAGE` (`MESSAGE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_cron_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `FINISHED` smallint(6) unsigned NOT NULL default '0',
  `TASK` varchar(64) NOT NULL default '',
  `SUB_TASK` varchar(255) NOT NULL default '',
  `RUN_TIME` varchar(128) NOT NULL default '',
  `TO_STOP` datetime,
  PRIMARY KEY  (`ID`),
  KEY `STAMP` (`STAMP`),
  KEY `FINISHED` (`FINISHED`),
  KEY `TASK` (`TASK`),
  KEY `RUN_TIME` (`RUN_TIME`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_cron_task` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `TASK_TYPE` varchar(32) NOT NULL default '',
  `TASK` varchar(255) NOT NULL default '',
  `IN_PROGRESS` tinyint(4) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY  (`ID`),
  KEY `TASK_TYPE` (`TASK_TYPE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_cron_email_log` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `TASK_PROCESS_ID` int(11) unsigned NOT NULL default '0',
  `SUBJECT` varchar(255) NOT NULL default '',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `ERRORS` text,
  PRIMARY KEY  (`ID`),
  KEY `STAMP` (`STAMP`),
  KEY `TASK_PROCESS_ID` (`TASK_PROCESS_ID`)
) Type=MyISAM;

CREATE TABLE `{PREF}_tracker_email_schedule` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `SUBJECT` varchar(255) NOT NULL default '',
  `BODY` text,
  `RECEPIENTS` text,
  `ATTACH_TYPE` varchar(10) NOT NULL default '',
  `SEND_AT` datetime default NULL,
  `SCHEDULE` varchar(32) default NULL,
  `PARAMETERS` text,
  `ENABLED` tinyint(3) unsigned NOT NULL default '0',
  `COMMENT` varchar(255) NOT NULL default '',
  `SEARCH_KEY` varchar(64) NOT NULL default '',
  `LAST_SENT` datetime default NULL,
  PRIMARY KEY  (`ID`),
  KEY `SEND_AT` (`SEND_AT`),
  KEY `ENABLED` (`ENABLED`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `SEARCH` (`SEARCH_KEY`)
) Type=MyISAM;

CREATE TABLE `{PREF}_tracker_host` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `GRP_ID` int(11) unsigned NOT NULL default '0',
  `HOST` varchar(128) NOT NULL default '',
  `KEY_VAR` varchar(32) default NULL,
  `BAN` enum('0','1') NOT NULL default '0',
  `STAT_IGNORE` enum('0','1') NOT NULL default '0',
  `CHARSET` varchar(128) NOT NULL default '',
  `RENEW_CHARSET` tinyint(4) unsigned NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `HOST` (`HOST`),
  KEY `STAT_IGNORE` (`STAT_IGNORE`),
  KEY `BAN` (`BAN`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_host_grp` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME_KEY` varchar(32) default NULL,
  `NAME` varchar(128) NOT NULL default '',
  `KEY_VAR` varchar(32) default NULL,
  `BAN` enum('0','1') NOT NULL default '0',
  `REGULAR_EXPRESSION` text NOT NULL,
  `REGULAR_EXPRESSION2` text NOT NULL,
  `CHARSET` varchar(128) NOT NULL default '',
  `RENEW_CHARSET` tinyint(4) unsigned NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `NAME_KEY` (`NAME_KEY`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_ip` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `IP` varchar(15) NOT NULL default '',
  `IGNORED` enum('0','1') NOT NULL default '0',
  `DESCRIPTION` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `IP` (`IP`),
  KEY `IGNORED` (`IGNORED`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_ip_ignore` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL,
  `TEMPLATE` varchar(15) NOT NULL default '',
  `START_INT` int(11) unsigned NOT NULL default '0',
  `END_INT` int(11) unsigned NOT NULL default '0',
  `DESCRIPTION` varchar(128) NOT NULL default '',
  `IP` varchar(15) NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `TEMPLATE` (`TEMPLATE`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `IP_RANGE` (`START_INT`,`END_INT`),
  KEY `IP` (`IP`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_keyword` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `KEYWORD` varchar(255) NOT NULL,
  `MD5_SEARCH` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `MD5_SEARCH` (`MD5_SEARCH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_license` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `KEY_ID` varchar(64) NOT NULL default '',
  `LICENSE_KEY` text NOT NULL,
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_page_query` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `SITE_HOST_ID` int(11) unsigned NOT NULL default '0',
  `PAGE_ID` int(11) unsigned NOT NULL default '0',
  `QUERY_ID` int(11) unsigned NOT NULL default '0',
  `TITLE_ID` int(11) unsigned NOT NULL default '0',
  `GRP_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `TRIPLE2` (`SITE_HOST_ID`,`PAGE_ID`,`QUERY_ID`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `PAGE_ID` (`PAGE_ID`),
  KEY `QUERY_ID` (`QUERY_ID`),
  KEY `DBL` (`SITE_ID`,`GRP_ID`),
  KEY `GRP_ID` (`GRP_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_page_title` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `MD5_SEARCH` varchar(32) NOT NULL default '',
  `TITLE` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `MD5_SEARCH` (`MD5_SEARCH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_path` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL,
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_path_step` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `PATH_ID` int(11) unsigned NOT NULL default '0',
  `CAMP_ID` int(11) unsigned NOT NULL default '0',
  `SPLIT_ID` int(11) unsigned NOT NULL default '0',
  `REF_GRP_ID` int(11) unsigned NOT NULL default '0',
  `REF_HOST_ID` int(11) unsigned NOT NULL default '0',
  `ACTION_ID` int(11) unsigned NOT NULL default '0',
  `ACTION_ITEM_ID` int(11) unsigned NOT NULL default '0',
  `PRODUCT_ID` int(11) unsigned NOT NULL default '0',
  `KEYWORD_ID` int(11) unsigned NOT NULL default '0',
  `PQ_ID` int(11) unsigned NOT NULL default '0',
  `ANY_ACTION` tinyint(4) unsigned NOT NULL default '0',
  `ANY_SALE` tinyint(4) unsigned NOT NULL default '0',
  `ANY_CAMPAIGN` tinyint(4) unsigned NOT NULL default '0',
  `ANY_SPLIT_TEST` tinyint(4) unsigned NOT NULL default '0',
  `ANY_REFERER` tinyint(4) unsigned NOT NULL default '0',
  `ANY_ENTRY` tinyint(4) unsigned NOT NULL default '0',
  `ANY_QUERY_STRING` tinyint(3) unsigned NOT NULL default '0',
  `FIRST_STEP` tinyint(4) unsigned NOT NULL default '0',
  `FIRST_SESSION` tinyint(4) unsigned NOT NULL default '0',
  `NO_OUTS` tinyint(4) unsigned NOT NULL default '0',
  `POSITION` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `PATH_ID` (`PATH_ID`),
  KEY `CAMP_ID` (`CAMP_ID`),
  KEY `SPLIT_ID` (`SPLIT_ID`),
  KEY `ACTION_ID` (`ACTION_ID`),
  KEY `PQ_ID` (`PQ_ID`),
  KEY `STEP_POSITION` (`FIRST_STEP`),
  KEY `POSITION` (`POSITION`),
  KEY `FIRST_SESSION` (`FIRST_SESSION`),
  KEY `NO_OUTS` (`NO_OUTS`),
  KEY `KEYWORD_ID` (`KEYWORD_ID`),
  KEY `REF_GRP_ID` (`REF_GRP_ID`),
  KEY `REF_HOST_ID` (`REF_HOST_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_periods` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `TEMPLATE` varchar(32) NOT NULL default '',
  `DELETED` enum('0','1') NOT NULL default '0',
  `SYSTEM_TEMPLATE` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `DELETED` (`DELETED`),
  KEY `SYSTEM_TEMPLATE` (`SYSTEM_TEMPLATE`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `TEMPLATE` (`TEMPLATE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_query` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `QUERY_STRING` text NOT NULL,
  `MD5_SEARCH` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `MD5_SEARCH` (`MD5_SEARCH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_referer` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REFERER` text NOT NULL,
  `MD5_SEARCH` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `MD5_SEARCH` (`MD5_SEARCH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_referer_set` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REFERER_ID` int(11) unsigned NOT NULL default '0',
  `HOST_ID` int(11) unsigned NOT NULL default '0',
  `NATURAL_KEY` int(11) unsigned NOT NULL default '0',
  `PROCESSED` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `REFERER_ID` (`REFERER_ID`),
  KEY `HOST_ID` (`HOST_ID`),
  KEY `NATURAL_KEY` (`NATURAL_KEY`),
  KEY `PROCESSED` (`PROCESSED`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_report_time_stat` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `JOIN_CNT` int(11) unsigned NOT NULL default '0',
  `ROWS_CNT` int(11) unsigned NOT NULL default '0',
  `RUN_TIME` varchar(128) NOT NULL default '0',
  `QUERY_TYPE` int(11) unsigned NOT NULL default '0',
  `QUERY_SET_ID` int(11) unsigned NOT NULL default '0',
  `GROUP_KEY` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `JOIN_CNT` (`JOIN_CNT`),
  KEY `ROWS_CNT` (`ROWS_CNT`),
  KEY `STAMP` (`STAMP`),
  KEY `QUERY_TYPE` (`QUERY_TYPE`),
  KEY `RUN_TIME` (`RUN_TIME`),
  KEY `QUERY_SET_ID` (`QUERY_SET_ID`),
  KEY `GROUP_KEY` (`GROUP_KEY`),
  KEY `TRPL1` (`JOIN_CNT`,`ROWS_CNT`,`QUERY_TYPE`),
  KEY `DBL1` (`GROUP_KEY`,`QUERY_TYPE`),
  KEY `DBL2` (`COMPANY_ID`,`QUERY_SET_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_sale_item` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_sale_set` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SALE_ID` int(11) unsigned NOT NULL default '0',
  `ITEM_ID` int(11) unsigned NOT NULL default '0',
  `QUANT` smallint(6) unsigned NOT NULL default '0',
  `COST` double(15,2) unsigned NOT NULL default '0.00',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `SALE_ID` (`SALE_ID`),
  KEY `ITEM_ID` (`ITEM_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_sale_tag_rel` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `SALE_ID` int(11) unsigned NOT NULL default '0',
  `TAG_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `TRIPLE` (`COMPANY_ID`,`SALE_ID`,`TAG_ID`),
  KEY `DBL` (`COMPANY_ID`,`SALE_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `SALE_ID` (`SALE_ID`),
  KEY `TAG_ID` (`TAG_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_site` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `HOST` varchar(255) NOT NULL default '',
  `SHOW_PAGE_TITLES` enum('0','1') NOT NULL default '0',
  `USE_HOSTS` enum('0','1') NOT NULL default '0',
  `COOKIE_DOMAIN` varchar(255) NOT NULL default '',
  `TEXT_ID` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `HOST` (`HOST`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `TEXT_ID` (`TEXT_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_site_host` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `HOST` varchar(128) NOT NULL default '',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `ENABLED` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`ID`),
  KEY `HOST` (`HOST`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `ENABLE` (`ENABLED`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_site_page` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `PATH` varchar(255) NOT NULL default '',
  `IGNORE_PAGE` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `PATH` (`PATH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_site_page_grp` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(128) NOT NULL default '',
  `REG_EXP` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `SITE_ID` (`SITE_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_split_page` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SPLIT_ID` int(11) unsigned NOT NULL default '0',
  `PAGE_ID` int(11) unsigned NOT NULL default '0',
  `QUERY_ID` int(11) unsigned NOT NULL default '0',
  `COUNTER` int(11) unsigned NOT NULL default '0',
  `FULL_PATH` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `SPLIT_ID` (`SPLIT_ID`),
  KEY `DBL` (`PAGE_ID`,`QUERY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_split_test` (
  `ID` int(11) NOT NULL auto_increment,
  `SUB_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `REMEMBER_PAGE` enum('0','1') NOT NULL default '0',
  `DISTR_METHOD` tinyint(4) unsigned NOT NULL,
  `NEXT_DISTR_ID` int(11) unsigned NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `SUB_ID` (`SUB_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_static_report` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) NOT NULL default '0',
  `GROUP_ID` int(11) unsigned NOT NULL default '0',
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `SITES` text NOT NULL,
  `MODE` varchar(32) NOT NULL default '',
  `LAST_UPDATED` datetime NOT NULL default '0000-00-00 00:00:00',
  `DESCRIPTION` text NOT NULL,
  `SYSTEM_NAME` varchar(64) NOT NULL default '',
  `ADDITIONAL_TASK` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `MODE` (`MODE`),
  KEY `SYSTEM_NAME` (`SYSTEM_NAME`),
  KEY `USER_ID` (`USER_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_static_report_archive` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `PERIOD` varchar(32) NOT NULL default '',
  `MIN_ARCHIVE_START_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `DBL` (`REPORT_ID`,`PERIOD`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `PERIOD` (`PERIOD`),
  KEY `MIN_ARCHIVE_START_DATE` (`MIN_ARCHIVE_START_DATE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_static_report_group` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_static_report_periods` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `PERIOD` varchar(64) NOT NULL default '',
  `DAY_TIME` smallint(6) unsigned NOT NULL default '0',
  `NEXT_UPDATE_TIME` datetime NOT NULL default '0000-00-00 00:00:00',
  `UPDATE_PERIOD_CNT` int(11) unsigned NOT NULL default '0',
  `UPDATE_PERIOD` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `NEXT_UPDATE_TIME` (`NEXT_UPDATE_TIME`),
  KEY `DAY_TIME` (`DAY_TIME`),
  KEY `PERIOD` (`PERIOD`),
  KEY `REPORT_ID` (`REPORT_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_sub_campaign` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `SUB_ID` int(11) unsigned NOT NULL default '0',
  `TYPE` enum('0','1') NOT NULL default '0',
  `SRC_ID` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `CAMPAIGN_ID` (`SUB_ID`),
  KEY `SRC_ID` (`SRC_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_tag` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `MD5_HASH` varchar(32) NOT NULL default '',
  `TAG` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `MD5_HASH` (`MD5_HASH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_user` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `SUPER_USER` enum('1','0') NOT NULL default '0',
  `MODIFIED` timestamp NOT NULL,
  `DEMO` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `USER_ID` (`USER_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_user_cache` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `CACHE_ID` int(11) unsigned NOT NULL default '0',
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  `FUNNEL_ID` int(11) unsigned NOT NULL default '0',
  `CUSTOM_REPORT` int(11) unsigned NOT NULL default '0',
  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `DONE` smallint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `USER_ID` (`USER_ID`),
  KEY `CACHE_ID` (`CACHE_ID`),
  KEY `STAMP` (`STAMP`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `DONE` (`USER_ID`,`DONE`),
  KEY `FUNNEL_ID` (`FUNNEL_ID`),
  KEY `CUSTOM_REPORT` (`CUSTOM_REPORT`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_user_column` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `HITS` tinyint(4) unsigned NOT NULL default '1',
  `SALES` tinyint(4) unsigned NOT NULL default '1',
  `ACTIONS` tinyint(4) unsigned NOT NULL default '1',
  `CLICKS` tinyint(4) unsigned NOT NULL default '1',
  `ROI` tinyint(4) unsigned NOT NULL default '1',
  `CONVERSIONS` tinyint(4) unsigned NOT NULL default '1',
  `GRAPHS` tinyint(4) unsigned NOT NULL default '1',
  `NEWRET` tinyint(4) unsigned NOT NULL default '0',
  `VISITS` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `USER_ID` (`USER_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_user_settings` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `ADVANCED_MODE` enum('0','1') NOT NULL default '0',
  `HELP_MODE` enum('0','1','2') NOT NULL default '2',
  `TIMEZONE` varchar(5) NOT NULL default 'a',
  `DEF_PATH_ORDER` varchar(255) NOT NULL default '',
  `PAGE_ENCODING` varchar(128) NOT NULL default '',
  `DISABLE_SMART` tinyint(4) unsigned NOT NULL default '0',
  `DISABLE_AJAX` tinyint(4) unsigned NOT NULL default '0',
  `CACHE_UPDATE_MODE` smallint(6) unsigned NOT NULL default '0',
  `GRAPH_PLACE` smallint(6) unsigned NOT NULL default '0',
  `TRAFFIC_MODE` tinyint(4) unsigned NOT NULL default '0',
  `HIDE_PATH_STEPS` varchar(255) NOT NULL default '',
  `CAN_CHANGE_SKIN` tinyint(4) unsigned NOT NULL DEFAULT '1',
  `ACTIVITY_ORDER` text,
  `ALLOW_SCHEDULE_EMAILS` tinyint(4) unsigned NOT NULL,
  `PERCENT_CALC` tinyint(4) unsigned NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `USER_ID` (`USER_ID`)
) Type=MyISAM;

CREATE TABLE `{PREF}_tracker_user_rss` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL,
  `PARAMS` varchar(255) NOT NULL,
  `LOG_ID` varchar(32) NOT NULL,
  `LAST_REC_DATE` datetime NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `USER_ID` (`USER_ID`),
  KEY `LOG_ID` (`LOG_ID`),
  KEY `LAST_REC_DATE` (`LAST_REC_DATE`)
) Type=MyISAM;

CREATE TABLE `{PREF}_tracker_visit_length` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `LEN1` int(11) unsigned NOT NULL default '0',
  `LEN2` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `DBL` (`LEN1`,`LEN2`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COOKIE_ID` varchar(32) NOT NULL default '',
  `LAST_IP_ID` int(11) unsigned NOT NULL default '0',
  `LAST_AGENT_ID` int(11) unsigned NOT NULL default '0',
  `FIRST_STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `LAST_STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
  `LAST_COUNTRY_ID` int(11) unsigned NOT NULL default '0',
  `LAST_CITY_ID` int(11) unsigned NOT NULL default '0',
  `LAST_RESOLUTION` varchar(20) NOT NULL default '',
  `PIXEL_DEPTH` smallint(4) NOT NULL default '0',
  `FLASH_VERSION` varchar(20) NOT NULL default '',
  `SESSION_COUNT` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `COOKIE_ID` (`COOKIE_ID`),
  KEY `LAST_AGENT_ID` (`LAST_AGENT_ID`),
  KEY `LAST_IP_ID` (`LAST_IP_ID`),
  KEY `FIRST_STAMP` (`FIRST_STAMP`),
  KEY `LAST_STAMP` (`LAST_STAMP`),
  KEY `FIRST_COUNTRY_ID` (`LAST_COUNTRY_ID`),
  KEY `SESSION_COUNT` (`SESSION_COUNT`),
  KEY `LAST_CITY_ID` (`LAST_CITY_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_action` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `GROUP_ID` int(11) unsigned NOT NULL default '0',
  `PAGE_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `SITE_HOST_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(128) NOT NULL default '',
  `QUERY` varchar(255) NOT NULL default '',
  `PATH` varchar(255) NOT NULL default '',
  `REDIRECT_URL` varchar(255) NOT NULL default '',
  `REDIRECT_CATCH` enum('0','1') NOT NULL default '0',
  `ITEM_VAR` varchar(32) NOT NULL default '',
  `ACTIVE` enum('0','1') NOT NULL default '0',
  `CODE_ACTION` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `PAGE_ID` (`PAGE_ID`),
  KEY `QUERY` (`QUERY`),
  KEY `SITE_ID` (`SITE_ID`),
  KEY `REDIRECT_CATCH` (`REDIRECT_CATCH`),
  KEY `ACTIVE` (`ACTIVE`),
  KEY `CODE_ACTION` (`CODE_ACTION`),
  KEY `GROUP_ID` (`GROUP_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_action_group` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `NAME` (`NAME`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_agent` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `BROWSER_ID` int(11) unsigned NOT NULL default '0',
  `OS_ID` int(11) unsigned NOT NULL default '0',
  `ENGINE_ID` int(11) unsigned NOT NULL default '0',
  `ROBOT_ID` int(11) unsigned NOT NULL default '0',
  `USER_AGENT` varchar(255) NOT NULL default '',
  `MD5_SEARCH` varchar(32) NOT NULL default '',
  `BROWSER_VERSION` varchar(32) NOT NULL default '',
  `OS_VERSION` varchar(32) NOT NULL default '',
  `ENGINE_VERSION` varchar(32) NOT NULL default '',
  `ROBOT_VERSION` varchar(32) NOT NULL default '',
  `BAN` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `BROWSER_ID` (`BROWSER_ID`),
  KEY `OS_ID` (`OS_ID`),
  KEY `ENGINE_ID` (`ENGINE_ID`),
  KEY `ROBOT_ID` (`ROBOT_ID`),
  KEY `BROWSER_VERSION` (`BROWSER_VERSION`),
  KEY `OS_VERSION` (`OS_VERSION`),
  KEY `ENGINE_VERSION` (`ENGINE_VERSION`),
  KEY `ROBOT_VERSION` (`ROBOT_VERSION`),
  KEY `BAN` (`BAN`),
  KEY `MD5_SEARCH` (`MD5_SEARCH`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_agent_browser` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME_KEY` varchar(32) NOT NULL default '',
  `NAME` varchar(128) NOT NULL default '',
  `ELEM_TYPE` varchar(32) NOT NULL default '',
  `BAN` tinyint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `NAME_KEY` (`NAME_KEY`),
  KEY `BAN` (`BAN`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_agent_engine` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME_KEY` varchar(32) NOT NULL default '',
  `NAME` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `NAME_KEY` (`NAME_KEY`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_agent_os` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME_KEY` varchar(32) NOT NULL default '',
  `NAME` varchar(128) NOT NULL default '',
  `ELEM_TYPE` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `NAME_KEY` (`NAME_KEY`),
  KEY `ELEM_TYPE` (`ELEM_TYPE`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_visitor_agent_robot` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `NAME_KEY` varchar(32) NOT NULL default '',
  `NAME` varchar(128) NOT NULL default '',
  `ELEM_TYPE` varchar(32) NOT NULL default '',
  `BAN` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `NAME_KEY` (`NAME_KEY`),
  KEY `BAN` (`BAN`),
  KEY `ELEM_TYPE` (`ELEM_TYPE`)
) Type=MyISAM;

CREATE TABLE `{PREF}_tracker_visitor_tag_rel` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `VISITOR_ID` int(11) unsigned NOT NULL default '0',
  `TAG_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `TRIPLE` (`COMPANY_ID`,`VISITOR_ID`,`TAG_ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`),
  KEY `VISITOR_ID` (`VISITOR_ID`),
  KEY `TAG_ID` (`TAG_ID`),
  KEY `DBL` (`COMPANY_ID`,`VISITOR_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_watch` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `USER_ID` int(11) unsigned NOT NULL default '0',
  `COMPANY_ID` int(11) unsigned NOT NULL default '0',
  `GRP_ID` int(11) unsigned NOT NULL default '0',
  `SITE_ID` int(11) unsigned NOT NULL default '0',
  `SUB_ID` int(11) unsigned NOT NULL default '0',
  `VISITOR_ID` int(11) unsigned NOT NULL default '0',
  `VISITOR_GRP_ID` int(11) unsigned NOT NULL default '0',
  `ACTION_ID` int(11) unsigned NOT NULL default '0',
  `ACTION_ITEM_ID` int(11) unsigned NOT NULL default '0',
  `SALE_ITEM_ID` int(11) unsigned NOT NULL default '0',
  `REPORT_ID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `COMPANY_ID` (`COMPANY_ID`,`USER_ID`),
  KEY `GRP_ID` (`GRP_ID`,`USER_ID`),
  KEY `SITE_ID` (`SITE_ID`,`USER_ID`),
  KEY `SUB_ID` (`SUB_ID`,`USER_ID`),
  KEY `VISITOR_ID` (`VISITOR_ID`,`USER_ID`),
  KEY `ACTION_ID` (`ACTION_ID`,`USER_ID`),
  KEY `ACTION_ITEM_ID` (`ACTION_ITEM_ID`,`USER_ID`),
  KEY `REPORT_ID` (`REPORT_ID`,`USER_ID`),
  KEY `SALE_ITEM_ID` (`SALE_ITEM_ID`,`USER_ID`),
  KEY `VISITOR_GRP_ID` (`VISITOR_GRP_ID`,`USER_ID`)
) Type=MyISAM;


CREATE TABLE `{PREF}_tracker_xml` (
  `ID` int(11) unsigned NOT NULL auto_increment,
  `FILENAME` varchar(32) NOT NULL default '',
  `MODIFIED` datetime NOT NULL default '0000-00-00 00:00:00',
  `CONTENT` text NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `FILENAME` (`FILENAME`),
  KEY `MODIFIED` (`MODIFIED`)
) Type=MyISAM;
