/* 'calendar'
 * 
 * (c) stuffed guys
 * written by johann kuindji
 * jQuery required
 */

var sgCalendars = []
function createCalendar(options) {
    var c = new calendar(options);
    c.closeAfterSelect = true;
    c.inx = sgCalendars.push(c);
    return c;
}

function calendar(options) {

    if (!options) options = {}
    if (!options.fieldID) return alert('field id is required')
    this.fld = $('#'+options.fieldID)
    this.icon = options.iconID?$('#'+options.iconID):false
    this.wrapper = this.parent = false
    this.options = options

    this.keep = true //   
    this.opened = this.filled = false
    this.month = this.year = this.day = false
    this.closeAfterSelect = options.closeAfterSelect?options.closeAfterSelect:false

    extendCalendar(this)
}

function extendCalendar(o) {

    o.create = function() {
        o.parent = o.options.parentSelector?$(o.options.parentSelector):$('body')
        if (o.parent.length == 0) return alert('could not find parent element');
        o.wrapper=$('<div></div>').addClass(o.options.cls?o.options.cls:'Calendar').
                                   appendTo(o.parent)
        o.wrapper.click(function() {return (o.keep=true)})
        $(document).click(function() {if (o.keep) return (o.keep=false); o.hide()})
        $(window).bind('resize',o.setPosition)
        if (o.options.createCallback) o.options.createCallback(o) 
    }

    o.show = function() {
        if (o.opened) return false
        o.keep = true
        if (!o.wrapper) o.create()
        if (!o.filled) o.draw()
        o.setPosition()
        o.wrapper.show()
        o.opened = true
    }

    o.hide = function() {
        o.opened = false
        o.wrapper.hide()
    }

    o.setValue = function(date,draw) {
        o.fld.val(date); 
        (!o.closeAfterSelect || draw)?o.draw():o.hide()
        return false
    }

    o.getValue = function() {
        var date = o.fld.val()
        if (date) {
            var arr = date.split('-')
            var dateObj = new Date(arr[0],(arr[1]-1),arr[2],0,0,0)
            if (!dateObj) dateObj = new Date()
            if (dateObj.getFullYear()>maxYear) return o.setValue(maxYear+'-12-31',true)
            if (dateObj.getFullYear()<minYear) return o.setValue(minYear+'-01-01',true)
        }
        else dateObj = new Date()
        return dateObj
    }

    o.setPosition = function() {
        var fPosition = o.fld.offset()
        if (o.parent.get(0).tagName.toLowerCase() != 'body') {
            pPosition = o.parent.offset()
            fPosition.left -= pPosition.left
            fPosition.top -= pPosition.top
        }
        o.wrapper.css({
            left:(fPosition.left+ (o.options.offsetLeft ? o.options.offsetLeft : 0)) +'px',
            top:(fPosition.top + o.fld.height()+
                 (o.options.offsetTop ? o.options.offsetTop : 7)) +'px'})
    }

    o.draw = function() {
        var dateValue = o.getValue()
        if (!dateValue) return false
        var month = o.month = dateValue.getMonth()+1; 
        var year = o.year = dateValue.getFullYear(); 
        var day = o.day = dateValue.getDate();
        var curValue = new Date()
        var curMonth = curValue.getMonth()+1;
        var curYear = curValue.getFullYear(); 
        var curDay = curValue.getDate();          
        var daysCount = o.daysInMonth(month,year)
    	var firstDayNum = (new Date(month+"/1/"+year)).getDay()
    	var lastDayNum = (new Date(month+"/"+daysCount+"/"+year)).getDay()
    	if (firstDayNum == 0) firstDayNum = 7; if (lastDayNum == 0) lastDayNum = 7

        var HTML = ''
        HTML += '<div id="Date"><span id="PrevMonth">&laquo;</span>'
        HTML += '<span id="SelectedDate">'+months[month]+" "+day+'</span>'
        HTML += '<span id="NextMonth">&raquo;</span></div>'

    	HTML += '<div id="Select"><select id="MonthSelect">'
    	for (var i = 1; i <= 12; i++) {
    		HTML += '<option value='+i+' '
            if (i == month) HTML += 'selected'
            HTML += '>'+months[i]+'</option>'
    	}
    	HTML += '</select><select id="YearSelect">';
    	for (var i = minYear; i <= maxYear; i++) {
    		HTML += '<option value='+i+' '
            if (i == year) HTML += 'selected'
    		HTML += '>'+i+'</option>'
    	}
    	HTML += '</select></div>'     

        //  
        HTML += '<div id="Table"><div id="WeekDays">'
        for (var i = 1; i < 8; i++) HTML += "<span><b>"+weekDays[i]+"</b></span>"
        HTML += '</div><div id="Days">'

    	//  
    	if (firstDayNum > 1) {
    		var prevMonthDCount = o.daysInMonth(month==1?12:month-1, month==1?year-1:year)
    		for (var i = (prevMonthDCount-(firstDayNum-2)); i <= prevMonthDCount; i++) {
    			HTML += '<p>'+i+'</p>'
    		}
    	}

    	//  
        var wd = firstDayNum
    	for (var i = 1; i <= daysCount; i++) {
    		if (wd > 7) wd = 1
            HTML += '<span '
            if (i==day) HTML += ' id="Selected" ';
            else if (i == curDay && month==curMonth && year==curYear) HTML += ' id="Today" ';
            HTML += '>'+i+'</span>'
    		wd++
    	}

    	//   
    	if (wd < 8) for (var i = 1; i <= (7-(wd-1)); i++) { HTML += '<p>'+i+'</p>' }

        HTML += '</div></div>'
        HTML += '<div id="Today">'+todayIs+' '+months[curMonth]+' '+curDay+'</div>'

        o.wrapper.html(HTML)
        
        $('#Days span',o.wrapper).click(o.getDayClick)
        $('div#Today',o.wrapper).click(function(){o.setValue(curYear+'-'+
            +o.twoDigit(curMonth)+'-'+o.twoDigit(curDay))})
        $('#MonthSelect, #YearSelect',o.wrapper).change(o.selectChange)
        $('#Days p',o.wrapper).click(o.getOtherDayClick)
        $('#PrevMonth',o.wrapper).click(function(){o.changeMonth(-1)})
        $('#NextMonth',o.wrapper).click(function(){o.changeMonth(1)})
    }

    o.getDayClick = function(ev) {
        var eventData = jQuery.eventData(ev)
        var date = String(o.year)+'-'
        date += String(o.twoDigit(o.month))+'-'
        date += String(o.twoDigit($(eventData.target).text()))
        o.setValue(date)
    }

    o.selectChange = function() {
        var date = String($('#YearSelect',o.wrapper).val())+'-'
        date += String(o.twoDigit($('#MonthSelect',o.wrapper).val()))+'-'
        date += String(o.twoDigit(o.day))
        o.setValue(date,true)
    }

    o.changeMonth = function(val) {
        var date = String(o.year)+'-'
        date += String(o.twoDigit(o.month+val))+'-'
        date += String(o.twoDigit(o.day))
        o.setValue(date,true)
    }

    o.getOtherDayClick = function(ev) {
        var eventData = jQuery.eventData(ev)
        var day = $(eventData.target).text()
        o.month += (day < 8)?1:-1
        var date = String(o.year)+'-'
        date += String(o.twoDigit(o.month))+'-'
        date += String(o.twoDigit(day))
        o.setValue(date,true)
    }

    o.daysInMonth = function(month, year) {
        return (new Date((new Date(year, month, 1)) - 86400000)).getDate()
    }

    o.twoDigit = function(int) {
        var str = int.toString()
        return (str.length==1)?'0'+str:str
    }

    if (o.icon) o.icon.css('cursor','pointer').bind('click',o.show)
    else o.fld.bind('focus',o.show)
}