<?
function GetPagesList($HostId, $Templ=false, $PageStart=false, $Limit=false, $PageGrpId=false)
{
	$PagesArr=array();

    $LimitStr="";
	if ($Limit&&!$PageStart) $LimitStr=" LIMIT $Limit";
	if ($Limit&&$PageStart) $LimitStr="LIMIT $PageStart, $Limit";
	
    $Like="";
	if ($Templ) $Like=" AND PATH LIKE '%$Templ%'";

    if ($PageGrpId) {
        $Query = "
            SELECT DISTINCT P.ID, P.*, GR.GRP_ID
                FROM ?_site_page P 
                LEFT JOIN ?_page_grp_rel GR 
                    ON GR.PAGE_ID=P.ID
                WHERE P.SITE_ID=$HostId 
                $Like AND GR.GRP_ID=$PageGrpId
                ORDER BY GRP_ID ASC, PATH ASC 
                $LimitStr
        ";
    }
    else {
        $Query = "
            SELECT DISTINCT P.ID, 
                MIN(GR.QUERY_ID) AS MIN_ID,    
                P.*, 0 AS GRP_ID
                FROM ?_site_page P
                LEFT JOIN ?_page_grp_rel GR
                    ON GR.PAGE_ID=P.ID
                WHERE P.SITE_ID=$HostId $Like
            GROUP BY P.ID
                HAVING MIN_ID>0 OR MIN_ID IS NULL
            ORDER BY PATH ASC
            $LimitStr
        ";
    }
	$Sql = new Query($Query);
	while ($Row=$Sql->Row()) {
		$Row->PATH=htmlspecialchars($Row->PATH);
		$PagesArr[]=$Row;
	}
    if (count($PagesArr)>0) return $PagesArr;
	else return false;
}

function GetActions($PageId=false, $HostId=false)
{
	if (!ValidId($PageId)||!ValidId($HostId)) return false;
	$Actions=array();
	$Query = "SELECT * FROM ?_visitor_action WHERE PAGE_ID = ? AND SITE_ID=?";
	$Sql = new Query($Query, false, $PageId, $HostId);
	while ($Row=$Sql->Row()) {
		$Actions[]=$Row;
	}
	if (count($Actions)>0) return $Actions;
	else return false;
}

function GetEvent($Id)
{
	global $Db;
	$Query = "SELECT * FROM ?_visitor_action WHERE ID = ?";
	$Event=$Db->Select($Query, false, $Id);
	return $Event;
}


function GetPage($Id)
{
	global $Db;
	$Query = "SELECT * FROM ?_site_page WHERE ID = ?";
	$Page=$Db->Select($Query, false, $Id);
	return $Page;
}


function GetCompany($Id)
{
	global $Db;
	$Query = "SELECT * FROM ?_client WHERE ID = ?";
	$Company=$Db->Select($Query, false, $Id);
	return $Company;
}


function GetHost($Id, $NoHosts=false)
{
	global $Db;
	$Query = "SELECT * FROM ?_site WHERE ID = $Id";
	$EditHost=$Db->Select($Query);
	if (!$NoHosts) {
		$EditHost->Hosts=array();		
		$Query = "SELECT * FROM ?_site_host WHERE SITE_ID=? ORDER BY HOST";
		$SubSql=new Query($Query, false, $EditHost->ID);	
		while ($SubRow=$SubSql->Row()) $EditHost->Hosts[]=$SubRow;
	}
	return $EditHost;
}

function GetHostsList($Id)
{
	global $ShowExpand;
	$HostsArr=array();
	$Query= "SELECT * FROM ?_site WHERE COMPANY_ID = ? ORDER BY HOST";
	$Sql = new Query($Query, false, $Id);
	while ($Row = $Sql->Row()) {
		$Row->Hosts=array();
		if ($Row->USE_HOSTS) $ShowExpand+=1;
		$Query = "SELECT * FROM ?_site_host WHERE SITE_ID=? ORDER BY HOST";
		$SubSql=new Query($Query, false, $Row->ID);
		while ($SubRow=$SubSql->Row()) $Row->Hosts[]=$SubRow;
		$HostsArr[]=$Row;
	}
	if (count($HostsArr)>0) return $HostsArr;
	else return false;
}


function CreateStatTables($Prefix=false)
{
	global $Db;
	if (!$Prefix) return false;
	$Query = "
		CREATE TABLE `?_{$Prefix}_stat_log` (
	  `ID` int(11) unsigned NOT NULL auto_increment,
	  `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
	  `VISITOR_ID` int(11) unsigned NOT NULL default '0',
	  `SITE_ID` int(11) unsigned NOT NULL default '0',
	  `SITE_HOST_ID` int(11) unsigned NOT NULL default '0',
	  `COOKIE_LOG` int(11) unsigned NOT NULL default '0',
	  `PAGE_ID` int(11) unsigned NOT NULL default '0',
	  `QUERY_ID` int(11) unsigned NOT NULL default '0',
	  `REFERER_SET` int(11) unsigned NOT NULL default '0',
	  `IP_ID` int(11) unsigned NOT NULL default '0',
	  `AGENT_ID` int(11) unsigned NOT NULL default '0',
	  `SCHEME` enum('0','1') NOT NULL default '0',
	  PRIMARY KEY  (`ID`),
      KEY `STAMP` (`STAMP`),
	  KEY `VISITOR_ID` (`VISITOR_ID`),
	  KEY `COOKIE_LOG` (`COOKIE_LOG`),
	  KEY `DBL_1` (`SITE_ID`,`STAMP`),
	  KEY `PAGE_ID` (`PAGE_ID`),
	  KEY `QUERY_ID` (`QUERY_ID`),
	  KEY `SITE_ID` (`SITE_ID`),
	  KEY `REFERER_SET` (`REFERER_SET`),
	  KEY `SITE_HOST_ID` (`SITE_HOST_ID`),
	  KEY `IP_ID` (`IP_ID`),
	  KEY `AGENT_ID` (`AGENT_ID`),
      KEY `QUERY_TRIPLE` (`SITE_HOST_ID`,`PAGE_ID`,`QUERY_ID`)
	) TYPE=MyISAM
	";
	$Db->Query($Query);
	$Query = "
		CREATE TABLE `?_{$Prefix}_stat_action` (
	  `ID` int(11) unsigned NOT NULL auto_increment,
	  `LOG_ID` int(11) unsigned NOT NULL default '0',
	  `ACTION_ID` int(11) unsigned NOT NULL default '0',
	  `SITE_ID` int(11) unsigned NOT NULL default '0',
	  PRIMARY KEY  (`ID`),
	  KEY `LOG_ID` (`LOG_ID`),
	  KEY `ACTION_ID` (`ACTION_ID`),
	  KEY `SITE_ID` (`SITE_ID`)
	)  TYPE=MyISAM
	";
	$Db->Query($Query);
	$Query = "
	CREATE TABLE `?_{$Prefix}_stat_click` (
	  `ID` int(11) unsigned NOT NULL auto_increment,
	  `LOG_ID` int(11) unsigned NOT NULL default '0',
	  `KEYWORD_ID` int(11) unsigned NOT NULL default '0',
	  `CAMP_ID` int(11) unsigned NOT NULL default '0',
	  `SOURCE_HOST_ID` int(11) unsigned NOT NULL default '0',
	  `FRAUD` enum('0','1') NOT NULL DEFAULT '0',
	  PRIMARY KEY  (`ID`),
	  KEY `LOG_ID` (`LOG_ID`),
	  KEY `KEYWORD_ID` (`KEYWORD_ID`),
	  KEY `CAMP_ID` (`CAMP_ID`),
	  KEY `SOURCE_HOST_ID` (`SOURCE_HOST_ID`),
	  INDEX `FRAUD` (`FRAUD`)
	) TYPE=MyISAM
	";
	$Db->Query($Query);
	$Query = "
		CREATE TABLE `?_{$Prefix}_stat_sale` (
	  `ID` int(11) unsigned NOT NULL auto_increment,
	  `LOG_ID` int(11) unsigned NOT NULL default '0',
	  `COST` float(9,2) unsigned NOT NULL default '0.00',
	  `SITE_ID` int(11) unsigned NOT NULL default '0',
	  `CUSTOM_ORDER_ID` varchar(64) NOT NULL default '',
	  `ADDITIONAL` text NOT NULL,
	  PRIMARY KEY  (`ID`),
	  KEY `LOG_ID` (`LOG_ID`),
	  KEY `SITE_ID` (`SITE_ID`),
	  KEY `CUSTOM_ORDER_ID` (`CUSTOM_ORDER_ID`)
	) TYPE=MyISAM
	";
	$Db->Query($Query);
	$Query = "
		CREATE TABLE `?_{$Prefix}_stat_split` (
	  `ID` int(11) unsigned NOT NULL auto_increment,
	  `LOG_ID` int(11) unsigned NOT NULL default '0',
	  `SPLIT_ID` int(11) unsigned NOT NULL default '0',
	  PRIMARY KEY  (`ID`),
	  KEY `LOG_ID` (`LOG_ID`),
	  KEY `SPLIT_ID` (`SPLIT_ID`)
	)  TYPE=MyISAM
	";
	$Db->Query($Query);
	$Query = "
		CREATE TABLE `?_{$Prefix}_stat_undef` (
      `ID` int(11) unsigned NOT NULL auto_increment,
      `ADDRESS` varchar(255) NOT NULL default '',
      `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
      `SITE_ID` int(11) unsigned NOT NULL default '0',
      `IP_ID` int(11) unsigned NOT NULL default '0',
      PRIMARY KEY  (`ID`),
      KEY `ADDRESS` (`ADDRESS`),
      KEY `STAMP` (`STAMP`),
      KEY `SITE_ID` (`SITE_ID`),
      KEY `IP_ID` (`IP_ID`)
	) TYPE=MyISAM
	";
	$Db->Query($Query);

	$Query = "
        CREATE TABLE `?_{$Prefix}_cache` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `QUERY_SET_ID` int(11) unsigned NOT NULL default '0',
          `LAST_CACHED` datetime NOT NULL default '0000-00-00 00:00:00',
          `LAST_CACHED_TZ` varchar(5) NOT NULL default '',
          `TO_CACHE` enum('0','1') NOT NULL default '0',
          `CACHE_TYPE` tinyint(4) NOT NULL default '0',
          `MODE` varchar(32) NOT NULL default '',
          `UPDATE_INTERVAL` int(11) unsigned NOT NULL default '0',
          `USE_CNT` int(11) unsigned NOT NULL default '0',
          `ADDITIONAL_TASK` varchar(255) NOT NULL default '',
          PRIMARY KEY  (`ID`),
          KEY `QUERY_SET_ID` (`QUERY_SET_ID`),
          KEY `DBL` (`QUERY_SET_ID`),
          KEY `TO_CACHE` (`TO_CACHE`),
          KEY `CACHE_TYPE_DBL` (`CACHE_TYPE`,`LAST_CACHED`),
          KEY `MODE` (`MODE`),
          KEY `USE_CNT` (`USE_CNT`)
        ) TYPE=MyISAM
	";
	$Db->Query($Query);


	$Query = "
        CREATE TABLE `?_{$Prefix}_cache_cron_log` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `CACHE_ID` int(11) unsigned NOT NULL default '0',
          `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
          `RUN_TIME` varchar(128) NOT NULL default '0',
          `ERRORS` text NOT NULL,
          `RUN_ID` varchar(32) NOT NULL default '',
          `REPORT_ID` int(11) unsigned NOT NULL default '0',
          `RUN_MODE` smallint(6) unsigned NOT NULL default '0',
          `CPU_LOAD` double(15,2) unsigned NOT NULL default '0.00',
          `CPU_LOAD_BEFORE` double(15,2) unsigned NOT NULL default '0.00',
          `MESSAGE` text NOT NULL,
          PRIMARY KEY  (`ID`),
          KEY `RUN_ID` (`RUN_ID`),
          KEY `STAMP` (`STAMP`),
          KEY `RUN_TIME` (`RUN_TIME`),
          KEY `CPU_LOAD` (`CPU_LOAD`),
          KEY `CPU_LOAD_BEFORE` (`CPU_LOAD_BEFORE`),
          KEY `CACHE_ID` (`CACHE_ID`)
        ) TYPE=MyISAM
	";
	$Db->Query($Query);


	$Query = "
        CREATE TABLE `?_{$Prefix}_cache_data` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `CACHE_ID` int(11) unsigned NOT NULL default '0',
          `FULL_DATA` longtext NOT NULL,
          `ROWS_CNT` int(11) unsigned NOT NULL default '0',
          `LIMIT_EXCEED` tinyint(4) unsigned NOT NULL default '0',
          `ADDITIONAL` varchar(32) NOT NULL default '',
          PRIMARY KEY  (`ID`),
          KEY `CACHE_ID` (`CACHE_ID`),
          KEY `ADDITIONAL` (`ADDITIONAL`)
        ) TYPE=MyISAM
	";
	$Db->Query($Query);


	$Query = "
        CREATE TABLE `?_{$Prefix}_cache_query_set` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `MD5_SEARCH` varchar(32) NOT NULL default '',
          `PARAMS_SET` text NOT NULL,
          PRIMARY KEY  (`ID`),
          KEY `MD5_SEARCH` (`MD5_SEARCH`)
        ) TYPE=MyISAM
	";
	$Db->Query($Query);

    $Query = "
    CREATE TABLE `?_{$Prefix}_cache_popularity` (
      `ID` bigint(20) unsigned NOT NULL auto_increment,
      `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
      `CACHE_ID` int(11) unsigned NOT NULL default '0',
      `ADDITIONAL_TASK` varchar(255) NOT NULL default '',
      `ADDITIONAL` varchar(32) NOT NULL default '',
      PRIMARY KEY  (`ID`),
      KEY `STAMP` (`STAMP`),
      KEY `CACHE_ID` (`CACHE_ID`),
      KEY `ADDITIONAL` (`ADDITIONAL`)
    ) TYPE=MyISAM";
    $Db->Query($Query);
    
    $Query = "
        CREATE TABLE `?_{$Prefix}_static_report_cache` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `REPORT_ID` int(11) unsigned NOT NULL default '0',
          `PERIOD_ID` int(11) unsigned NOT NULL default '0',
          `CACHE_ID` int(11) unsigned NOT NULL default '0',
          PRIMARY KEY  (`ID`),
          KEY `REPORT_ID` (`REPORT_ID`),
          KEY `CACHE_ID` (`CACHE_ID`),
          KEY `DBL` (`REPORT_ID`,`CACHE_ID`),
          KEY `PERIOD_ID` (`PERIOD_ID`),
          KEY `DBL2` (`REPORT_ID`,`PERIOD_ID`)
        ) TYPE=MyISAM
    ";
    $Db->Query($Query);   

	$Query = "
    CREATE TABLE `?_{$Prefix}_stat_session` (
      `ID` int(11) unsigned NOT NULL auto_increment,
      `START_LOG_ID` int(11) unsigned NOT NULL default '0',
      `END_LOG_ID` int(11) unsigned NOT NULL default '0',
      `FIRST_SESSION` tinyint(4) unsigned NOT NULL default '0',
      `VISITOR_ID` int(11) unsigned NOT NULL default '0',
      `VISIT_LENGTH` int(11) unsigned NOT NULL default '0',
      `VISIT_DEPTH` int(11) unsigned NOT NULL default '0',
      `VISIT_PATH` varchar(32) NOT NULL default '',
      PRIMARY KEY  (`ID`),
      UNIQUE KEY `DBL2` (`ID`,`FIRST_SESSION`),
      UNIQUE KEY `DBL` (`START_LOG_ID`,`END_LOG_ID`),
      KEY `START_LOG_ID` (`START_LOG_ID`),
      KEY `FIRST_SESSION` (`FIRST_SESSION`),
      KEY `VISIT_LENGTH` (`VISIT_LENGTH`),
      KEY `VISIT_DEPTH` (`VISIT_DEPTH`),
      KEY `VISIT_PATH` (`VISIT_PATH`)
    ) TYPE=MyISAM
	";
	$Db->Query($Query);
    
    $Query = "
    CREATE TABLE `?_{$Prefix}_stat_session_log` (
      `ID` int(11) unsigned NOT NULL auto_increment,
      `SESSION_ID` int(11) unsigned NOT NULL default '0',
      `LOG_ID` int(11) unsigned NOT NULL default '0',
      `PREV_LOG_ID` int(11) unsigned NOT NULL default '0',
      PRIMARY KEY  (`ID`),
      KEY `SESSION_ID` (`SESSION_ID`),
      KEY `LOG_ID` (`LOG_ID`),
      KEY `PREV_LOG_ID` (`PREV_LOG_ID`)
    ) TYPE=MyISAM
    ";
    $Db->Query($Query);
    
    $Query = "
    CREATE TABLE `?_{$Prefix}_stat_session_path` (
      `ID` int(11) unsigned NOT NULL auto_increment,
      `SESSION_ID` int(11) unsigned NOT NULL default '0',
      `PATH` text NOT NULL,
      PRIMARY KEY  (`ID`),
      KEY `SESSION_ID` (`SESSION_ID`)
    ) TYPE=MyISAM
    ";
    $Db->Query($Query);    
    
    $Query = "
    CREATE TABLE `?_{$Prefix}_static_archive_cache` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `REPORT_ID` int(11) unsigned NOT NULL default '0',
          `PERIOD_ID` int(11) unsigned NOT NULL default '0',
          `CACHE_ID` int(11) unsigned NOT NULL default '0',
          `SITE_ID` int(11) NOT NULL default '0',
          `NEXT_ARCHIVE_START_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
          `NEXT_ARCHIVE_END_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
          PRIMARY KEY  (`ID`),
          KEY `REPORT_ID` (`REPORT_ID`),
          KEY `CACHE_ID` (`CACHE_ID`),
          KEY `SITE_ID` (`SITE_ID`),
          KEY `PERIOD_ID` (`PERIOD_ID`),
          KEY `NEXT_ARCHIVE_START_DATE` (`NEXT_ARCHIVE_START_DATE`),
          KEY `NEXT_ARCHIVE_END_DATE` (`NEXT_ARCHIVE_END_DATE`)
        ) TYPE=MyISAM
    ";
    $Db->Query($Query);        
    
    $Query = "
        CREATE TABLE `?_{$Prefix}_bot_log` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `SITE_ID` int(11) unsigned NOT NULL default '0',
          `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
          `UA_ID` int(11) unsigned NOT NULL default '0',
          `PQ_ID` int(11) unsigned NOT NULL default '0',
          `IP_ID` int(11) unsigned NOT NULL default '0',
          `REFERER_SET` int(11) unsigned NOT NULL default '0',
          `SCHEME` tinyint(4) unsigned NOT NULL default '0',
          PRIMARY KEY  (`ID`),
          KEY `SITE_ID` (`SITE_ID`),
          KEY `STAMP` (`STAMP`),
          KEY `UA_ID` (`UA_ID`),
          KEY `PQ_ID` (`PQ_ID`),
          KEY `IP_ID` (`IP_ID`),
          KEY `REFERER_SET` (`REFERER_SET`)
        ) Type=MyISAM
    ";
    $Db->Query($Query);            
    
    $Query = "
        CREATE TABLE `?_{$Prefix}_delayed` (
          `ID` int(11) unsigned NOT NULL auto_increment,
          `REQUEST_TYPE` tinyint(4) unsigned NOT NULL default '0',
          `STAMP` datetime NOT NULL default '0000-00-00 00:00:00',
          `VISITOR_COOKIE` varchar(32) NOT NULL default '',
          `IP` varchar(15) NOT NULL default '',
          `BOT_LOG` tinyint(4) unsigned NOT NULL default '0',
          `VARS` text NOT NULL,
          `COOKIE_VARS` text NOT NULL,
          PRIMARY KEY  (`ID`),
          KEY `REQUEST_TYPE` (`REQUEST_TYPE`),
          KEY `STAMP` (`STAMP`),
          KEY `IP` (`IP`),
          KEY `VISITOR_COOKIE` (`VISITOR_COOKIE`)
        ) Type=MyISAM
    ";
    $Db->Query($Query);

}

function DropStatTables($Prefix=false)
{
	global $Db;
	if (!$Prefix) return false;
	$Query = "DROP TABLE ?_{$Prefix}_stat_log";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_stat_action";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_stat_click";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_stat_sale";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_stat_split";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_stat_undef";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_cache";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_cache_cron_log";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_cache_data";
	$Db->Query($Query);
	$Query = "DROP TABLE ?_{$Prefix}_cache_query_set";
	$Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_cache_popularity";
    $Db->Query($Query);    
	$Query = "DROP TABLE ?_{$Prefix}_static_report_cache";
	$Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_stat_session";
    $Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_stat_session_log";
    $Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_stat_session_path";
    $Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_static_archive_cache";
    $Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_bot_log";
    $Db->Query($Query);
    $Query = "DROP TABLE ?_{$Prefix}_delayed";
    $Db->Query($Query);
}

?>