<?

require_once SELF.'/lib/reports/do_cache.func.php';
require_once SELF.'/lib/reports/misc.func.php';
require_once SELF.'/lib/reports/export_params.func.php';
require_once SELF.'/class/cache_v2.class.php';
require_once SELF.'/class/mail/Mail.php';
require_once SELF.'/class/mail/mime.php';
require_once SYS.'/system/class/convertcharset/convert_charset.class.php';

function PrepareLogForEmail($Log=false, $CpId=false, $Additional='', $FileType='xls', $Params=array()) {
    if (!$Log || !$CpId) return false;
    global $Db, $nsProduct, $nsUser, $Logs, $nsLang, $nsTemplate, $Lang, $Settings;
    $nsLang->TplInc('report.logs');
    $Additional = urldecode($Additional);
    if (defined('CRON_MODE')) DummyUser($nsUser, $CpId);
    $Add = array();
    if (trim($Additional)) @parse_str($Additional, $Add);
    $_REQUEST = array_merge($_REQUEST, $Add);
    if (@$Params['NoRowsLimit']) $_REQUEST['NoLimit']=true;
    $_REQUEST['Mode']=$Log;
    $_REQUEST['CpId']=$CpId;
    $ReturnMode = 'DATAOBJ';
    include SELF.'/actions/report.logs.php';
    if (empty($R->Rows)) return false;
    $ExportParams = $R->ExportParams;
    return array('Content'=> $R->FileData($FileType, 'data', @$ExportParams),
                         'Filename'=>$R->Filename($FileType),
                         'ExportParams'=>$ExportParams);
}

function PrepareReportForEmail($CacheId=false, $CpId=false, $Additional='', $FileType='xls', $Params=array()) {
    if (!$CacheId || !$CpId) return false;
    global $Db, $nsUser, $LangConfig;
    $Query = "SELECT C.*, Q.PARAMS_SET
        FROM ?_{$CpId}_cache C
            INNER JOIN ?_{$CpId}_cache_query_set Q ON Q.ID=C.QUERY_SET_ID
        WHERE C.ID=?
    ";
    $Cache = $Db->Select($Query, false, $CacheId);
    if (!$Cache) return false;
    $CacheParams = @unserialize(@$Cache->PARAMS_SET);
    $CacheObj = new nsQueryCache($CpId, false, $CacheId);
    $StartStamp = false;
    $EndStamp = false;

    if ($Additional) $CacheObj->Additional=$CacheObj->TaskToArr(urldecode($Additional)); //  PAID  NATURAL
    if ($CacheObj->HasData()) {
        $Vars = DoCache($Cache, $CpId, true, $Additional, 'VARS');
        $StartStamp = @$Vars['Report']->StartDate ? $Vars['Report']->StartDate : @$Vars['Report']->StartStamp;
        $EndStamp = @$Vars['Report']->EndDate ? $Vars['Report']->EndDate : @$Vars['Report']->EndStamp;
        if (!@$Params['SplitId']) {
            $Vars['Report']->StatArr = $CacheObj->GetData();
            $RData=CacheReportData($CpId, $Vars);
        }
        else {
            $Vars['Report']->StatArr = $CacheObj->GetData();
            $Vars['Report']->SplitStat = V(@unserialize(@$Vars['Report']->StatArr[0]), array());
            $Vars['Report']->PageStat = V(@unserialize(@$Vars['Report']->StatArr[1]), array());
            $RData=SplitReportData($CpId, $Vars);
        }
    }
    else {
        $RData = DoCache($Cache, $CpId, true, $Additional, 'DATAOBJ');
        $StartStamp = @$RData->Report->StartDate ? $RData->Report->StartDate : @$RData->Report->StartStamp;
        $EndStamp = @$RData->Report->EndDate ? $RData->Report->EndDate : @$RData->Report->EndStamp;
    }
    if (empty($RData->Rows)) return false;
    $RData->CacheId=$CacheId;
    $ExportParams = array_merge( V($RData->ExportParams, array()),
                                                            ExportParams( array('Mode'=>$Cache->MODE, 'CacheId'=>@$CacheId,
                                                                               'StartDate'=>$StartStamp,
                                                                               'EndDate'=>$EndStamp,
                                                                               'Name'=>@$RData->ReportCaptionLast,
                                                                               'ReportValues'=>@$RDara->ReportValues) )
                                );
    $RData->TopCaption = @$Params['Subject'];
    return array('Content'=> $RData->FileData($FileType, 'data', @$ExportParams),
                         'Filename'=>$RData->Filename($FileType),
                         'ExportParams'=>$ExportParams);
}

function SendReport($Receips = array(), $FileData=array(), $Params=array()) {
    global $Settings, $LangConfig, $Lang;

    $Content = @$FileData['Content'];
    $Filename = @$FileData['Filename'];
    $ExportParams = V($FileData['ExportParams'], array());
    if (!$Content || !$Filename) return false;
    if (!@$Params['Subject']) return false;
    $Charset = 'UTF-8';
    $BodyAddition = '';
    $Ch = new nsConvertCharset();

    if (!is_array($Receips)) {
        $tmp = explode("\n", $Receips);
        $Receips = array();
        foreach ($tmp as $em) if (trim($em)) $Receips[]=$em;
    }

    if (!empty($ExportParams)) {
        $BodyAddition = "\n------------------------\n";
        foreach ($ExportParams as $k=>$v) {
            if (!$v) continue;
            if (isset($Lang[$k])) $v = preg_replace('/[:]/','',$Lang[$k]).': '.$v;
            $BodyAddition .= "$v\n";
        }
    }

    $Params['Subject']= $Ch->Convert( V($Params['Subject']) , $LangConfig['charset'],$Charset );
    $Params['Body'] = $Ch->Convert( V($Params['Body']) , $LangConfig['charset'], $Charset );
    $Filename = $Ch->Convert( $Filename ,$LangConfig['charset'],$Charset );
    $BodyAddition = $Ch->Convert( $BodyAddition, $LangConfig['charset'], $Charset );
    if ($BodyAddition) $Params['Body'] .= $BodyAddition;

    $Params['SendAs']=V($Params['SendAs']);

    $Mime = &new Mail_Mime("\n");
    $Mime->_build_params['head_encoding']='base64';
    $Mime->_build_params['html_charset']=$Charset;
    $Mime->_build_params['text_charset']=$Charset;
    $Mime->_build_params['head_charset']=$Charset;
    $Mime->_build_params['ignore-iconv']=true;
    $Headers['From']=@$Settings['All']->FROM_EMAIL;
    if (!$Headers['From']) $Headers['From'] = 'nobody@nohost.ext';
    $Headers["Content-Type"] = "text/plain; charset=$Charset";
    $Headers['Cc']='';
    $Headers['Subject'] = $Params['Subject'];

    $Mime->setTXTBody($Params['Body']);

    $To = $Receips;
    $Mime->addAttachment($Content,
        ($Params['SendAs']=='xls'? 'application/vnd.ms-excel' : 'text/plain'),
        $Filename, false
    );

    $MBody = $Mime->get();
    $Headers = $Mime->headers($Headers);
    $Mail =& Mail::factory('mail');
    foreach ($To as $Email) $Mail->send($Email, $Headers, $MBody);
}

function EmailGetNextDate($Period='', $LastStamp=false) {
    if (!$Period) return '';
    global $Db;
    $Arr = explode('-', $Period);
    $Cnt = $Arr[0];
    $P = $Arr[1];
    $Wd = @$Arr[2];
    $Now = $LastStamp ? $LastStamp : time();
    $Intv=array('d'=>'DAY', 'm'=>'MONTH', 'y'=>'YEAR');

    $Year = date('Y', $Now);
    $StartDay = $StartMonth = false;
    if ($P=='m') { $StartDay = 1; $StartMonth = date('n', $Now);}
    if ($P=='y') { $StartDay = 1; $StartMonth = 1; }
    if ($P=='d') { $StartDay = date('j', $Now); $StartMonth = date('n', $Now); }
    if ($P=='w') {
        $w = date('w', $Now);
        if ($w==0) $w=7;
        if ($w > 1) {
            $Stamp = $Db->ReturnValue("SELECT UNIX_TIMESTAMP( DATE_ADD(?, INTERVAL ? DAY))", date('Y-m-d H:i:s', $Now), -($w-1));
            $StartDay = date('j', $Stamp);
            $StartMonth = date('n', $Stamp);
            $Year = date('Y', $Stamp);
        }
        else {
            $StartDay = date('j', $Now);
            $StartMonth = date('n', $Now);
        }
        $P='d';
        $Cnt = $Cnt*7;
    }

    $Stamp = mktime (0,0,0,$StartMonth, $StartDay, $Year);
    $I = $Intv[$P];
    $Stamp = $Db->ReturnValue("SELECT UNIX_TIMESTAMP( DATE_ADD(?, INTERVAL ? $I))", date('Y-m-d H:i:s', $Stamp), $Cnt);
    $w = date('w', $Stamp);
    if ($Wd && $w != $Wd) {
        if ($Wd < $w) $Cnt = 7 - ($w-$Wd);
        else $Cnt  = $Wd-$w;
        $Stamp = $Db->ReturnValue("SELECT UNIX_TIMESTAMP( DATE_ADD(?, INTERVAL ? DAY))", date('Y-m-d H:i:s', $Stamp), $Cnt);
    }
    return date('Y-m-d H:i:s', $Stamp);
}

function ScheduleInterval($Schedule='') {
    if (!$Schedule) return 0;
    $Arr = explode('-', $Schedule);
    $Int = $Arr[0];
    if ($Arr[1]=='w') $Int = $Int*7;
    if ($Arr[1]=='m') $Int = $Int*30;
    if ($Arr[1]=='y') $Int = $Int*260;
    $Int = $Int*1440;
    return $Int;
}

?>