<?

require_once SELF."/lib/geo/geoipcity.php";

function UpdateVisitorsLocation()
{

    global $Db;
    global $StartRow,$UpdateRowStep;
    $LimitStr=($UpdateRowStep)?"LIMIT $StartRow, $UpdateRowStep":"";
    $tmp = GeoAvailable();
    $GeoIp = @$tmp['GeoIp'] ? SELF."/store/{$tmp['GeoIp']}" : false;
    $GeoCity = @$tmp['GeoCity'] ? SELF."/store/{$tmp['GeoCity']}" : false;
    if (!$GeoIp && !$GeoCity) return false;
    $CountryArr=array();
    $CityArr=array();

    $gi = geoip_open($GeoCity?$GeoCity:$GeoIp,GEOIP_STANDARD);
    $Updated=0;

    $Query = "
        SELECT V.ID, I.IP, V.LAST_COUNTRY_ID, V.LAST_CITY_ID
        FROM ?_visitor V
            INNER JOIN ?_ip I ON I.ID=V.LAST_IP_ID 
        WHERE (".(($GeoIp||$GeoCity)?"LAST_COUNTRY_ID=0":"")." ".(($GeoCity)?" OR LAST_CITY_ID=0":"").")
        $LimitStr
    ";
    $Sql = new Query($Query);

    while ($Row=$Sql->Row()) {
        $CountryId=0; $CityId=0;
        if ($Row->LAST_COUNTRY_ID) $CountryId=$Row->LAST_COUNTRY_ID;
        if ($Row->LAST_CITY_ID) $CityId=$Row->LAST_CITY_ID;

        if ($GeoCity) $Rec=GeoIP_record_by_addr($gi,$Row->IP);
        else {
            $CId=geoip_country_id_by_addr($gi,$Row->IP);
            $Rec=  (object) array();
            $Rec->country_code=@$gi->GEOIP_COUNTRY_CODES[$CId];
            $Rec->country_name=@$gi->GEOIP_COUNTRY_NAMES[$CId];
        }
        if (!@$Rec->area_code) $Rec->area_code = null;
        if (!@$Rec->dma_code) $Rec->dma_code = null;
        if (!@$Rec->postal_code) $Rec->postal_code = null;
        $CountryId=intval($CountryId);
        $CityId=intval($CityId);

        if (@$Rec->country_code&&!$CountryId) {
            if (!@$CountryArr[$Rec->country_code]) {
                $Query = "SELECT ID FROM ?_country WHERE CODE = ?";
                $CountryId=$Db->ReturnValue($Query,$Rec->country_code);
            } else $CountryId=@$CountryArr[$Rec->country_code];
            
            if (!$CountryId) {
                $Query = "INSERT INTO ?_country (CODE,NAME) VALUES (?,?)";
                $Db->Query($Query,$Rec->country_code,$Rec->country_name);
                $CountryId=$Db->LastInsertId;
            }
            $CountryArr[$Rec->country_code]=$CountryId;
        }

        if ($GeoCity && isset($Rec->latitude) && isset($Rec->longitude) && @$Rec->city && 
              @$CityArr[$Rec->latitude][$Rec->longitude][$Rec->city] && !$CityId) $CityId=@$CityArr[$Rec->latitude][$Rec->longitude][$Rec->city];

        if ($GeoCity && isset($Rec->latitude) && isset($Rec->longitude) && @$Rec->city && !$CityId) {
            $CityId = false;
            if ($Rec->country_code == 'US') {
                $Query = "SELECT * FROM ?_city WHERE (LATITUDE=? AND LONGITUDE=?) OR AREA_CODE = ? OR DMA_CODE=?";
                $SubSql = new Query($Query,false,$Rec->latitude,$Rec->longitude,$Rec->area_code, $Rec->dma_code);
                $ByCode = array();
                while ( ($City = $SubSql->Row()) && !$CityId) {
                    if ($City->LATITUDE == $Rec->latitude && $City->LONGITUDE==$Rec->longitude) $CityId = $City->ID;
                    elseif ($Rec->city == $City->NAME && 
                               ((double)$Rec->latitude > (double)$City->LATITUDE-1 && (double)$Rec->latitude < (double)$City->LATITUDE+1) &&
                               ((double)$Rec->longitude > (double)$City->LONGITUDE-1 && (double)$Rec->longitude < (double)$City->LONGITUDE+1) && 
                               ($Rec->area_code == $City->AREA_CODE && $Rec->dma_code == $City->DMA_CODE)
                               ) {
                                    $City->LaDiff = abs( $City->LATITUDE - $Rec->latitude );
                                    $City->LoDiff = abs( $City->LONGITUDE - $Rec->longitude );
                                    $ByCode[$City->ID]=$City;
                    }
                }
                if (!$CityId) foreach ($ByCode as $k=>$v) {
                    if ($CityId && $v->LaDiff <= $ByCode[$CityId]->LaDiff && $v->LoDiff <= $ByCode[$CityId]->LoDiff)  $CityId=$k;
                    else $CityId=$k;
                }
            }
            else {
                $Query = "SELECT ID FROM ?_city WHERE LATITUDE=? AND LONGITUDE=?";
                $CityId=$Db->ReturnValue($Query,$Rec->latitude,$Rec->longitude);
            }
            if (!$CityId) {
                $Query = "INSERT INTO ?_city (COUNTRY_ID,NAME,LATITUDE,LONGITUDE,AREA_CODE,DMA_CODE) VALUES (?,?,?,?,?,?)";
                $Db->Query($Query,$CountryId,$Rec->city,$Rec->latitude,$Rec->longitude, $Rec->area_code, $Rec->dma_code);
                $CityId=$Db->LastInsertId;
            }
            $CityArr[$Rec->latitude][$Rec->longitude][$Rec->city]=$CityId;
        }

        $Query = "UPDATE ?_visitor SET LAST_COUNTRY_ID=?, LAST_CITY_ID=? WHERE ID=?";
        $Db->Query($Query,$CountryId,$CityId,$Row->ID);

        if ($CityId != @$Row->LAST_CITY_ID || $CountryId != @$Row->LAST_COUNTRY_ID) $Updated++;
    }

    return $Updated;
}

?>