<?

class nsDebugConsole
{
    var $SqlArr;
    var $DoExplain;
    var $MsgArr;
    
    
    function nsDebugConsole()
    {
        $this->SqlArr=array();
        $this->MsgArr=array();
        $this->DoExplain=false;
        $this->Stop=false;
    }
    
    function Clear()
    {
        $this->SqlArr=array();
        $this->MsgArr=array();
    }
    
    function ClearAndStop()
    {
        $this->Clear();
        $this->Stop=true;
    }
    
    function SqlStat($Query=false,$Time=0, $NumRows=0) {
        global $Db;
        if ($this->Stop) return false;
        $Db->NoDebug=true;
        $InsertQuery = "INSERT INTO query_log (QUERY,RUN_TIME,NUM_ROWS,STAMP) VALUES (?,?,?,NOW())";
        $Db->Query($InsertQuery,$Query,$Time,$NumRows);
        $Db->NoDebug=false;
    }
    
    
    function SqlRecord($Query=false, $Time=0, $Error=false, $NumRows=0)
    {
        if (!$Query) return false;
        if ($this->Stop) return false;
        global $Db;
        $Query = trim($Query);
        $ExplainArr=array();
        $Explain=$this->DoExplain;
        $Trace=array();
        $Alert=($Time<0.5)?false:true;
        if (!preg_match("/^SELECT\s.*/i",$Query)) $Explain=false;
        if (preg_match("/^EXPLAIN\s.*/i",$Query)) return false;
        
        if ($Explain) {
            $Db->DoPrepareQuery=false;
            $Sql = new Query("EXPLAIN $Query");
            $Db->DoPrepareQuery=true;
            $Sql->NoDebug=true;
            while ($Row=$Sql->Row()) $ExplainArr[]=$Row;
            $Sql->NoDebug=false;
        }

        $Query=nl2br($Query);            
        $Query=preg_replace("/\s+/i"," ",$Query);
        $Query=preg_replace("/([^a-zA-Z_]{1})([\d0-9]+)/", "\\1<span style=\"color:#6666CC;\">\\2</span>", $Query);
        $Query=preg_replace("/('[^']*')/", "<span style=\"color:#FF9900;\">\\1</span>", $Query);
        $Query=preg_replace("/(#.*\n)/", "<span style=\"color:#999999;\">\\1</span>", $Query);
        $Query=preg_replace("/(COUNT|SUM|IF|CONCAT|AVG)\(([^\)]+)\)/", "<span style=\"color:#FF0000;font-weight:bold;\">\\1</span>(\\2)", $Query);
        $Query=preg_replace("/\s{1}(FROM|JOIN|INNER JOIN|LEFT JOIN|GROUP|WHERE|ORDER|LIMIT|AND|ON)\s{1}/", " <span style=\"color:#0000FF;font-weight:bold;\">\\1</span> ", $Query);
        $Query=preg_replace("/\s{1}(BY|OR|AS|IN|BETWEEN)\s{1}/", " <span style=\"color:#555555;font-weight:bold;\">\\1</span> ", $Query);
        $Query=preg_replace("/(SELECT)/", " <span style=\"color:#0000FF;font-weight:bold;\">\\1</span> ", $Query);
        $Query=preg_replace("/\(/", "<span style=\"font-weight:bold;\">(</span>", $Query);
        $Query=preg_replace("/\)/", "<span style=\"font-weight:bold;\">)</span>", $Query);        

        $TraceArr=debug_backtrace();
        $Skip=false;

        for ($i=0;$i<count($TraceArr);$i++) {
            //if (in_array(ValidVar($TraceArr[$i]['class']), array("query", "database")) && isset($TraceArr[$i+1])) $Skip=false;
            if ($Skip) continue;
            $Inx=count($Trace);
            $Row=$TraceArr[$i];
            $Args="";
            if (ValidVar($Row['args'])) {
                $AA=array();
                foreach ($Row['args'] as $j=>$arg) {
                    if (!is_array($arg)&&!is_object($arg)&&!is_bool($arg)) $AA[$j]=$this->CutArg($arg);
                    elseif (is_array($arg)||is_object($arg)) $AA[$j]=$this->ArrToStr($arg);
                    elseif (is_bool($arg))  $AA[$j]=($arg)?"true":"false"; 
                    else $AA[$j]="'$arg'";
                }
                $Args=implode(", ",$AA);
            }
            $Trace[$Inx]=$Row['file']." on line <b>".$Row['line']."</b>";
            $Trace[$Inx].=( (ValidVar($Row['class']) && ValidVar($Row['type'])) || ValidVar($Row['function']))?" - ":"";
            $Trace[$Inx].=(ValidVar($Row['class']) && ValidVar($Row['type']) )?"<b>".$Row['class']."</b>".$Row['type']:"";
            $Trace[$Inx].=(ValidVar($Row['function'])?"<b>".$Row['function']."(</b>$Args<b>)</b>":"");
        }
        $Trace=array_reverse($Trace);

        $Arr['Query']=$Query;
        $Arr['Time']=$Time;
        $Arr['Error']=$Error;
        $Arr['Explain']=$ExplainArr;
        $Arr['Trace']=$Trace;
        $Arr['Alert']=$Alert;
        $Arr['Rows']=$NumRows;
        
        $this->SqlArr[]=$Arr;

    }

    function Backtrace()
    {
        $TraceArr=debug_backtrace();
        $Trace = array();

        foreach ($TraceArr as $Row) {
            $Inx=count($Trace);
            $Args="";
            if (@$Row['args']) {
                $AA=array();
                foreach ($Row['args'] as $j=>$arg) {
                    if (!is_array($arg) && !is_object($arg) && !is_bool($arg)) $AA[$j]=$this->CutArg($arg);
                    elseif (is_array($arg) || is_object($arg)) $AA[$j]=$this->ArrToStr($arg);
                    elseif (is_bool($arg))  $AA[$j]=($arg)?"true":"false"; 
                    else $AA[$j]="'$arg'";
                }
                $Args=implode(", ",$AA);
            }
            $Trace[$Inx]=$Row['file']." on line <b>".$Row['line']."</b>";
            $Trace[$Inx].=( @($Row['class'] && @$Row['type']) || @$Row['function'])?" - ":"";
            $Trace[$Inx].=( @$Row['class'] && @$Row['type'] )?"<b>".$Row['class']."</b>".$Row['type']:"";
            $Trace[$Inx].=( @$Row['function'] )?"<b>".$Row['function']."(</b>$Args<b>)</b>":"";
        }

        $Trace=array_reverse($Trace);            
        return $Trace;
    }    
    
    function ArrToStr($Arr)
    {
        $Str="array(";
        foreach ($Arr as $i=>$val) {
            if ($i>0) $Str.=", ";
            if (is_array($val) || is_object($val) ) $Str.=$this->ArrToStr($val);
            else $Str.=$this->CutArg($val);
        }
        $Str.=")";
    }
    
    function CutArg($Str)
    {
        if (strlen($Str)>10) $Str=substr($Str,0,10)."...";
        $Str=str_replace("'","",$Str);
        $Str=str_replace('"',"",$Str);
        $Str="'$Str'";       
        return $Str;
    }
    
    
    
    function DebugMessage($Msg=false)
    {
        if (!$Msg) return false;
        $this->MsgArr[]=$Msg;
    }
    
    
}

function SqlStat($Query=false,$Time=0, $Error=false, $NumRows=0)
{
    if (!$Query) return false;
    global $nsConsole;
    $nsConsole->SqlStat($Query, $Time, $NumRows);    
}

function SqlConsole($Query=false, $Time=false, $Error=false, $NumRows=0)
{
    if (defined("NS_TRACKING")) return false;
    if (!$Query) return false;
    global $nsConsole;
    $nsConsole->SqlRecord($Query, $Time, $Error, $NumRows);
}

?>